{
	This unit does the generations
}

{ Created in <=2000 - Copyright (C) Joel Yliluoma }


{$O-   -- code segment too large}

Unit NesMusa4;

Interface

Function WHex(w: Word): PChar;
Function BHex(b: Byte): PChar;

Procedure Show4; {pas}
Procedure Show6; {play}
Procedure Show7; {obj save, compressed}
Procedure Show8; {asm}
Procedure Show9; {obj save, doublecompressed}
Procedure Show10;{obj save, doublecompressed library}
Procedure Show11;{bas, fm}
Procedure Show13;{bas, sb}
Procedure Show14;{bas, multi}

Const
	HC: Array[0..16]Of Char = '0123456789ABCDEF';
	CompressorTemp: String[11] = 'nesmusa.$$$';
	DAPLBits: Byte = 10;

Const
	BasicNotes: Array[0..15]Of Array[0..3]Of Char =
		('c','c+','d','d#','e','f','f+','g','a-','a','a+','b','','','','');

Procedure DASM(Var f: Text; s: PChar; Ret: Boolean);

Type Kompressor = Procedure(UseLastChan: Boolean);

Implementation

Uses Crt, Objects, Strings, DosMem, NesMusa1, NesMusa2, WinDos, NesMusa5;

Const
	s: String[29] = 'DATABLCK';

Const
	PascalBlock1Txt =
		'{$A+,F-,G+,I-,Q-,R-,S-,X+,M 2048,0,0}'^J^J+
		'Uses Crt;'^J+
		'Const IRQ:Byte=';

	PascalBlock2Txt =
		';Var'^J+
		'SampleSize:Word;OldI0D,OldI08:Procedure;'^J+
		'TimeConst:Byte;SmpBuf,Cache,oBuf,s1';

	PascalBlock3Txt =
		':PChar;'^J+
		'IRQCounter,Rivi,Pitch,TicCount:Word;'^J+
		'IRQProblem,No_EOI: Boolean;'^J+
		'Volume:Array[0..';

	PascalBlock4Txt =
		');'^J^J+
		'Function StrNICmp(s1,s2:PChar;m:Word):Integer;Assembler;Asm push ds'^J+
		'cld;les di,s2;mov si,di;mov ax,m;mov cx,ax;jcxz @4;xchg ax,bx'^J+
		'xor ax,ax;cwd;repne scasb;sub bx,cx;mov cx,bx;mov di,si;lds si,s1'^J+
		'@1:repe cmpsb;je @4;mov al,ds:[si-1];cmp al,''a'';jb @2';
	PascalBlock5Txt = ';cmp al,''z'''^J'ja @';
	PascalBlock6Txt = '2;sub al,32;@2:mov dl,es:[di-1];cmp dl,''a'';jb @3';
	PascalBlock7Txt = '3;sub dl,32;@3:sub ax,dx;je @1;@4:pop ds End;'^J+
		'Function GetEnvVar(N:PChar):PChar;Var L:Word;P:PChar;Begin'^J+
		'For L:=0To 255Do If N[L]=#0 Then Break;';

	PascalBlock8Txt =
		'P:=Ptr(Word(Ptr(PrefixSeg,44)^),0);'^J+
		'While P^<>#0 Do Begin If(StrNICmp(P,N,L)=0)And(P[L]=''='')Then'^J+
		'Begin GetEnvVar:=P+L+1;Exit End;'^J+
		'While P^<>#0 Do Inc(P);Inc(P);End;GetEnvVar:=Nil ';

Const
	BasicBlock1Txt =
		'ON PLAY(1)GOSUB More'^J+
		'ON ERROR GOTO Virhe'^J+
		'PLAY ON'^J'PLAY"mbt200l64mln0'^J^J+
		'?"Generated by ';

	BasicBlock2Txt =
		'LOOP UNTIL INKEY$<>""'^J^J'SYSTEM'^J^J+
		'Virhe:'^J^I'RESUME NEXT'^J^J+
		'More:'^J^I'SELECT CASE Where'^J;

	BasicBlock3Txt =
		#9'END SELECT'^J+
		#9'Where=Where+1'^J+
		#9'IF Where>=';

	BasicBlock4Txt = 'THEN Where=';

	BasicBlock5Txt =
		'"'^M^J'?"Press a key"'^J+
		'DO'#9#9''' The music is on the background; do anything you wish here.'^J;

	BasicBlock6Txt = #10'RETURN'^J^J;

	BasicBlock7Txt =
		#10'Red:'^J+
		#9'IF RPos*2>=LEN(Red$)THEN'^J+
		#9#9'IF RIni THEN READ RNum,Reck'^J+
		#9#9'IF Reck<>RChk THEN ?"DATA ERROR";STR$(RNum);":",Reck,RChk:SYSTEM'^J+
		#9#9'RIni=1:RChk=0:RPos=0:READ Red$'^J+
		#9'ENDIF'^J+
		#9'b=VAL("&H"+MID$(Red$,RPos*2+1,2))'^J+
		#9'RPos=RPos+1:RChk=RChk+b';

	BasicBlock8Txt =
{		#9#9'V=Vol(j)^(1/SQR(104))*63/(63^(1/SQR(104)))'^J;}
		#9#9'V=Vol(j)'^J;

Const
	AsmBlock1Txt =
		'o 5 10'^J+
		'o 0 12'^J+
		'o 73 11'^J+
		'o bl 2'^J+
		'o bh 2'^J+
		'o dl 83h'^J+
		'o cl 3'^J+
		'o ch 3'^J+
		'o 1 10'^J+
		'$'^J#0;

Procedure TabFix(Var f: Text; Var f2: File; Const fn: String; Size: Word);
Var
	BRead, BufPtr, a: Word; b: Byte;
	Buf: Array[0..255]Of Char;
Begin
	Debug('Tab-fixing with temporary file...');
	Rename(f, CompressorTemp);
	Reset(f2, 1);
	Assign(f, fn);
	ReWrite(f);

	a := 0;
	BRead := 0;
	BufPtr := 0;
	Repeat
		If BRead = BufPtr Then
		Begin
			BufPtr := 0;
			BlockRead(f2, Buf, SizeOf(Buf), BRead);
			If BRead=0 Then Break
		End;

		b := Ord(Buf[BufPtr]);
		Inc(BufPtr);

		If b<>13 Then
		Begin
			If b=10 Then
			Begin
				a := 0;
				WriteLn(f);
			End
			Else If b=9 Then
			Begin
				Repeat
					Inc(a);
					Write(f, ' ')
				Until(a And(Size-1))=0;
			End
			Else If(b=Ord('?'))And(Size=2)Then
			Begin
				Inc(a, 6);
				Write(f, 'PRINT ')
			End
			Else
			Begin
				Write(f, Chr(b));
				Inc(a)
			End
		End
	Until False;

	Debug('Closing files after tab-fixing.');
	Close(f2);
	Erase(f2);
	Close(f)
End;

Procedure DaplKompress(UseLastChan: Boolean); Far;
Var
	f: TDosStream;
	Max, y, c: Byte;
	BPos, BLen, Len, w, d, a, b: Integer;
	OutName: String[12];
Begin
	OutName := CompressorTemp + #0;

	If Debugging Then WriteLn('Compressing to a temporary file ', CompressorTemp);

	If(@Player = @Show14)Or(@Player = @Show10)Then
	Begin
		f.Init(PChar(@OutName)+1, stOpen+stFindCreate+stDenyWrite);
		f.Seek(f.GetSize)
	End
	Else
		f.Init(PChar(@OutName)+1, stCreate+stDenyWrite);

	If Not UseLastChan Then
	Begin
		f.Write(Riveja, 2);
		f.Write(Looppaa, 2);
		If(AutoTicker)Or(@Player = @Show10)Then f.Write(TicPeriod, 1)
	End;

	Max := 3;
	If UseLastChan Then Max := LastChan;

	For y := 0 To Max Do
	Begin
		For w := 0 To Riveja-1 Do
		Begin
			BLen := 2;
			If Not NoBrains Then
			Begin
				a := w - ((1 Shl DAPLBits)-1);
				If a<0 Then a := 0;
				For d := a To w-1 Do
				Begin
					If Word(Laulu^[w][y]) = Word(Laulu^[d][y])Then
					Begin
						a := d;
						b := w;
						Len := 1;
						Repeat
							Inc(a);
							If MustTryMore Then
							Begin
								If a >= Riveja Then Break
							End
							Else
								If a >= w Then Break;

							Inc(b); If b >= Riveja Then Break;
							If Word(Laulu^[b][y]) <> Word(Laulu^[a][y])Then Break;
							Inc(Len)
						Until Len = (1 Shl (16-DAPLBits))-1;
						If Len > BLen Then
						Begin
							BLen := Len;
							BPos := w-d;
							If Len = (1 Shl (16-DAPLBits))-1 Then Break
						End
					End
				End
			End;
			If BLen > 3 Then
			Begin
				c := $FF;
				Inc(w, BLen-1);

				BLen := BLen Or((BPos Shr 8)Shl (16-DAPLBits));
				BPos := BPos And 255;
				f.Write(c, 1);
				f.Write(BLen, 1);
				f.Write(BPos, 1)
			End
			Else
				f.Write(Laulu^[w][y], 2)
		End
	End;

	Debug('Closing file after compressing.');
	f.Done;

	FileMode := 0
End;

Procedure Show4;
Var
	i: Word;
	j: Byte;
	f: Text;
	f2: File;
Begin
	DaplKompress(True);

	Debug('Opening output file, tmptmp.pas');

	Assign(f, 'tmptmp.pas');
	ReWrite(f);

	Write(f, PascalBlock1Txt, IRQ, ';Period:Array[0..11]Of LongInt=(');

	For i := 0 To 11 Do
	Begin
		Write(f, Period[i]);
		If i<11 Then Write(f, ',')
	End;
	Write(f, ');'^J+
		'BasePort:Word=$220;Rate=26950;Riveja=',Riveja,
		';'^J'Looppaa=',Looppaa,
		';TicLen=Rate Div ',TicPeriod, PascalBlock2Txt);
	If LastChan>=2 Then Write(f, ',s2');
	If LastChan>=3 Then Write(f, ',s3');

	Write(f, PascalBlock3Txt, LastChan,']Of Byte;'^J+
		'Herz,Pos:Array[0..',LastChan,']Of LongInt;'^J,
		'Var Laulu:Array[0..Riveja-1,0..',LastChan*2+1,']Of Byte;'^J+
		'Const Res:Array[0..');

	Debug('Reading the temporary file.');

	Assign(f2, CompressorTemp);
	Reset(f2, 1);

	Write(f, FileSize(f2)-1, ']Of Byte = (');

	i := 0;
	While Not Eof(f2)Do
	Begin
		If i=0 Then Write(f, #10#9);
		BlockRead(f2, j, 1);
		Write(f, j);
		If Eof(f2)Then Break;
		Write(f, ',');
		If j>99 Then Inc(i);
		If j>9 Then Inc(i);
		Inc(i, 2);
		If i>72 Then i := 0
	End;

	Debug('Writing the rest of file.');

	WriteLn(f, PascalBlock4Txt,
		PascalBlock5Txt, PascalBlock6Txt, PascalBlock5Txt,
		PascalBlock7Txt, PascalBlock8Txt,
		'End;'^J'Procedure ','_WriteDSP;',' Assembler; Asm');
	DASM(f, @_WriteDSP, False);
	WriteLn(f,
		'End;'^J'Procedure ','_BitDelay;',' Assembler; Asm');
	DASM(f, @_BitDelay, False);
	WriteLn(f,
		'End;'^J'Function _InitDSP: Boolean;',' Assembler; Asm');
	DASM(f, @_InitDSP, False);
	WriteLn(f,
		'End;'^J'Procedure ','_DoneDSP;',' Assembler; Asm');
	DASM(f, @_DoneDSP, False);
	WriteLn(f,
		'End;'^J'Procedure ','AllocMem(Var s; w: Word);',' Assembler; Asm',
		' @@0:mov bx,w;mov ah,48h;int 21h;jc @@3'^J+
		'@@4:les di,s;mov es:[di].word[0],0;mov es:[di].word[2],ax;jmp @@2'^J,
		'@@3:xor ax,ax;jmp @@4;@@2:',
		'End;'^J'Procedure ','UnAllocMem(Var s);',' Assembler; Asm',
		' mov ah,49h;les di,s;mov es,es:[di].word[2];int 21h ',
		'End;'^J'Procedure ','ReSize(Var s; w: Word);',' Assembler; Asm',
		' les di,s;mov bx,w;mov es,es:[di].word[2];mov ah,4Ah;int 21h ',
		'End;'^J'Procedure ','Palanen(Dest: PChar);'^J+
		'Var p:PChar;l:Integer;k:Word;j:Byte;Begin p:=Dest;'^J+
		'For l:=0 To TicCount-1 Do Begin For j:=0 To ',LastChan,' Do Begin'^J+
		'Volume[j]:=Hi(Word(Laulu[Rivi][j*2+1]) * ',GlobalVolume,');'^J+
		'If Laulu[Rivi][j*2] < 254 Then'^J+
		'Herz[j]:=Period[Laulu[Rivi][j*2]And 15] * (1 Shl (Laulu[Rivi][j*2]Shr 4))',
		'End;'^J,
		'For k:=TicLen-1 DownTo 0 Do Asm'^J+
		'xor cx,cx;mov di,',LastChan,
		';@@1:mov bx,di;mov al,byte ptr Volume[di];'^J,
		'cbw;or al,al;jz @@6;shl bx,2;db 66h;mov ax, word ptr Herz[bx]'^J+
		'db 66h;add word ptr Pos[bx],ax;mov ax,word ptr Pos[bx+1]');
	If LastChan>=3 Then WriteLn(f, 'cmp di,3;je @@2');
	WriteLn(f, 'shr ax,6');
	If LastChan>=2 Then WriteLn(f, 'cmp di,2;jne @@3;les si,s2;jmp @@4');
	If LastChan>=3 Then WriteLn(f, '@@2:les si,s3'^J'and ax,4095;jmp @@5');
	WriteLn(f, #10+
		'@@3:les si,s1;@@4:and ax,63;@@5:add si,ax'^J+
		'mov al,es:[si];mul byte ptr Volume[di];'^J,
		'add cx,ax;@@6:dec di'^J,
		'jns @@1;les di,p;shr cx,7;mov byte ptr es:[di],cl;inc word ptr p'^J+
		'End;Inc(Rivi);If Rivi >= Riveja Then Rivi:=Looppaa End ',
		'End;'^J'Procedure ','NewI08;Interrupt;Begin'^J,
		'If(IRQCounter<999)','Then Inc(IRQCounter);'^J+
		'If IRQProblem Then If(IRQCounter < 999)And(IRQCounter > 127)Then'^J+
		'Begin {Music has ended.}IRQCounter:=999 End;'^J,
		'If(IRQCounter=91)Or(IRQCounter > 140)Then {5 secs without sound? Help...}'^J+
		'Begin IRQProblem:=True;'^J,
		'If(IRQCounter<999)','Then {Tell about it};'^J,
		'If(IRQCounter<999)','Or((Mem[Seg0040:$6C]And 15)=0)Then'^J+
		'Begin _InitDSP;Asm mov No_EOI,1;',
		'mov al,IRQ;add al,8;mov byte ptr cs:[offset @@1],al;db 205;@@1:db 0',
		';mov No_EOI,0 End'^J+
		'End End; InLine($9C); OldI08 ',
		'End;'^J'Procedure ','NewI0D;Interrupt;Begin Asm mov dx,BasePort;add dx,14;in al,dx;'^J+
		'sub dx,4;in al,dx End;'^J,
		'If Not No_EOI Then Begin IRQCounter:=0;IRQProblem:=False ','End;'^J+
		'TimeConst:=256-1000000 Div Pitch;'^J,
		'Move(Cache^,SmpBuf^,SampleSize);Asm'^J,
		'mov bx,word ptr SmpBuf[2];mov dx,bx;shl bx,4;shr dx,12'^J,
		#9'add bx,word ptr SmpBuf'^J#9'adc dx, 0'^J#9'mov cx, SampleSize;',
		'mov al,','5; out 0A',
		'h,al'^J'mov al,','0;out 0C',
		'h,al'^J'mov al,','73;out 0B',
		'h,al'^J'mov al,','bl;out 02',
		'h,al'^J'mov al,','bh;out 02',
		'h,al'^J'mov al,','dl;out 83',
		'h,al'^J'mov al,','cl;out 03',
		'h,al'^J'mov al,','ch;out 03',
		'h,al'^J'mov al,','1;out 0A',
		'h,al'^J'mov al,','64;',
		'call _WriteDSP;mov al,','TimeConst;',
		'call _WriteDSP;mov al,','20'^J,
		'call _WriteDSP;mov al,','SampleSize.byte[','0]'^J,
		'call _WriteDSP;mov al,','SampleSize.byte[','1]'^J,
		'call _WriteDSP End;',
		'Palanen(Cache);Port[$21]:=Port[33]And Not(1 Shl IRQ);'^J+
		'If Not No_EOI Then Begin Port[32]:=32; Port[$A0]:=32 End ',
		'End;'^J'Procedure ','Player;Var i:Integer;'^J+
		'Begin LongInt(@OldI08):=MemL[0:8*4];'^J+
		'LongInt(@OldI0D):=MemL[0:(IRQ+8)*4];_InitDSP;'^J+
		'No_EOI:=False;MemL[0:(IRQ+8)*4]:=LongInt(@NewI0D);'^J+
		'AllocMem(oBuf,$1000+(',BufSize+15,')Shr 4);'^J+
		'If oBuf=Nil Then Begin WriteLn(''Memory error'');Exit End;'^J+
		'SmpBuf:=Ptr((Seg(oBuf^)+$FFF)And $F000, 0);'^J+
		'TicCount:=(',BufSize,' Div TicLen);'^J+
		'SampleSize:=TicCount*TicLen;'^J,
		'ReSize(oBuf, Seg(SmpBuf^) - Seg(oBuf^) + (SampleSize+15)Shr 4);'^J+
		'Mem [Seg(SmpBuf^)-1:0]:=Mem[Seg(oBuf^)-1:0];'+
		'MemW[Seg(SmpBuf^)-1:1]:=MemW[Seg(oBuf^)-1:1];'^J,
		'MemW[Seg(SmpBuf^)-1:3]:=(SampleSize+15)Shr 4;'+
		'MemL[Seg(SmpBuf^)-1:5]:=MemL[Seg(oBuf^)-1:5];'^J+
		'MemL[Seg(SmpBuf^)-1:9]:=MemL[Seg(oBuf^)-1:9];',
		'MemL[Seg(SmpBuf^)-1:12]:=MemL[Seg(oBuf^)-1:12];'^J+
		'MemW[Seg(oBuf^)-1:3]:=Seg(SmpBuf^) - Seg(oBuf^)-1;'+
		'MemW[Seg(oBuf^)-1:1]:=0;'^J,
		'AllocMem(Cache,(SampleSize+15)Shr 4);'^J+
		'If Cache=Nil Then Begin WriteLn(''Memory error'');Exit End;'^J+
		'AllocMem(s1,64);');
	If LastChan>=2 Then WriteLn(f, 'AllocMem(s2,64);');
	If LastChan>=3 Then WriteLn(f,
		'AllocMem(s3,4096);'^J+
		'  For i:=0 To 4095 Do s3[i]:=Chr(50 + Random(186));');
	WriteLn(f, 'For i:=0To 63Do');
	If LastChan>=2 Then WriteLn(f, 'Begin');
	WriteLn(f, 's1[i]:=Chr(Ord(i<16)*200);');
	If LastChan>=2 Then Write(f,
		'If i<32 Then s2[i]:=Chr(i*255 Div 31)Else s2[i]:=Chr((63-i)*255 Div 31)'^J,
		'End;'^J);
	WriteLn(f,
		'FillChar(SmpBuf^, SampleSize, 0);'+
		'FillChar(Cache^, SampleSize, 0);'+
		'Palanen(SmpBuf);'^J,
		'Asm mov al, 0D0h; call _WriteDSP End;'^J+
		'Pitch:=Rate;Rivi:=0;Asm ',
		'mov al,IRQ;add al,8;mov byte ptr cs:[offset @@1],al;db 0CDh;@@1:db 0',
		' End;'^J'MemL[0:8*4]:=LongInt(@NewI08);'^J+
		'WriteLn(''Generated by ',Title,'''^M^J''Press a key'');'^J,
		'Repeat Until KeyPressed;While KeyPressed Do ReadKey;'^J+
		'MemL[0:(IRQ+8)*4]:=LongInt(@OldI0D);MemL[0:8*4]:=LongInt(@OldI08);'^J,
		'UnAllocMem(SmpBuf); UnAllocMem(Cache);'^J+
		'UnAllocMem(s1);');
	If LastChan>=2 Then WriteLn(f, 'UnAllocMem(s2);');
	If LastChan>=3 Then WriteLn(f, 'UnAllocMem(s3);');
	WriteLn(f, '_DoneDSP ','End;'^J,
		'Var a,p:PChar;y,j,b,i:Word;Code:Integer;Buf:Array[0..128]Of Char;'^J+
		'Begin'^J+
		'If Test8086<2 Then Begin WriteLn(''386+ required.'');Exit End;'^J+
		'Write(''Decompressing...'');p:=@Res;For y:=0To ',LastChan,'Do Begin i:=0;Repeat'^J+
		'j',':=Ord(p^);Inc(p);',
		'b',':=Ord(p^);Inc(p);','If j=255 Then Begin j:=b;'^J,
		'b',':=Ord(p^);Inc(p);','b:=b+(j Shr 6)Shl 8;j:=j And 63;'^J+
		'While j>0 Do Begin'^J,
		'Laulu[i,y*2+',0,']:=Laulu[i-b,y*2+',0,'];'^J,
		'Laulu[i,y*2+',1,']:=Laulu[i-b,y*2+',1,'];'^J,
		'Dec(j);Inc(i)End End Else Begin'^J,
		'Laulu[i,y*2+',0,']:=j;',
		'Laulu[i,y*2+',1,']:=b;Inc(i)End Until i>=Riveja End;'^J+
		'WriteLn('' Done.'');'^J,
		'p:=GetEnvVar(''BLASTER'');If p<>Nil Then Begin'^J+
		'a:=p;While a^<>#0 Do Begin If a^=''I'' Then Break;Inc(a)End;If a^=#0 Then a:=Nil;'^J+
		'If a=Nil Then Begin WriteLn(''Ixx not found'');Exit End;'^J,
		'Inc(a);If(a[0]>''7'')Or(a[0]<''0'')Or((a[1]>=''0'')And(a[1]<=''9''))Then'^J+
		'Begin WriteLn(''IRQ>7'');Exit End;IRQ:=Ord(a[0])-48;'^J+
		'While p^<>#0 Do Begin If p^=''A'' Then Break;Inc(p)End;If p^=#0 Then p:=Nil;'^J+
		'If p=Nil Then Begin WriteLn(''Axx not found'');Exit End;'^J,
		'Inc(p);a:=Buf;While p^<>#0 Do Begin a^:=p^;Inc(p);Inc(a)End;a^:=p^;'^J+
		'a:=Buf;While a^<>#0 Do Begin If a^=#32 Then Break;Inc(a)End;If a^=#0 Then a:=Nil;'^J+
		'If a<>Nil Then Buf[a-Buf]:=#0; Val(Buf, BasePort, Code);'^J,
		'BasePort:=$200 + ((BasePort Div 10)Mod 10)Shl 4;'^J+
		'Player End End.');

	WriteLn('Written TMPTMP.PAS');

	Debug('Closing files');

	Close(f2);
	Close(f)
End;

Procedure Show6;
	Procedure Pause(Var t: Text; f: Boolean);
	Const PauseLen: Integer = 0;
	Var Max, a: Integer;
	Begin
		If f Then
			Inc(PauseLen)
		Else
		Begin
			If Not Optimizing
				Then If NoBrains
					Then a := 0
					Else a := 2
				Else If MustTryMore
					Then a := 6
					Else a := 4;
			While PauseLen > 0 Do
			Begin
				For a := 0 To Max Do
					If PauseLen <= 1 Shl a Then Break;
				Write(t, 'p',64 Shr a);
				Dec(PauseLen, 1 Shl a)
			End
		End
	End;
Var
	j: Byte;
	i, n: Float;
	Value: Array[0..2]Of Byte;
	Loop, Row: Integer;
	Oct: Byte;
	Octaves: LongInt;
	OctAdd: LongInt;
	f: Text; f2: File;

	Note, k,y, mo,d,wd: Word;
	h,mi,sec,s100: Word;
Begin
	If FileLoadDebug Then Debug('Opening output file TMPTMP.BAS');
	Assign(f, 'TMPTMP.BAS');
	ReWrite(f);

	GetDate(y,mo,d,wd);
	GetTime(h,mi,sec,s100);

	FillChar(Value, SizeOf(Value), 0);
	i := 0;
	Write(f, BasicBlock1Txt, Title,
		'"'^J'LOCATE,,1'^J'?"Generation time: ',
			d, '.', mo, '.', y, ' ',
			Chr(h Div 10+48), Chr(h Mod 10+48), ':',
			Chr(mi Div 10+48), Chr(mi Mod 10+48), ':',
			Chr(sec Div 10+48), Chr(sec Mod 10+48),
			', file: ', Name, BasicBlock5Txt, BasicBlock2Txt);

	Oct := 3;
	Row := 0;
	Octaves := 0;
	OctAdd := 0;
	Loop := 0;
	Repeat
		Write(f, #9^I'CASE ',Row,':PLAY"');
		If Row = Loop Then Write(f, 'o',Oct);
		Inc(Row);

		For k := 0 To 7 Do
		Begin
			For j := 0 To 2 Do
			Begin
				If Laulu^[Round(i)][j].Volume=0 Then Value[j] := 0
				Else If(i<Spiid)
				Or(Laulu^[Round(i      )][j].Volume
				 > Laulu^[Round(i-Spiid)][j].Volume)
				Or(Laulu^[Round(i      )][j].Note
				 <>Laulu^[Round(i-Spiid)][j].Note)Then
				Begin

					Note := Laulu^[Round(i)][j].Note And 15;
					If Laulu^[Round(i)][j].Note < 254 Then
						Value[j] := Laulu^[Round(i)][j].Note;
					{If j=0 Then Inc(Value[j], 16)}
				End;

				If Value[j]=0 Then Pause(f, True)
				Else
				Begin
					Pause(f, False);

					Inc(Octaves, Value[j]Shr 4);
					Inc(OctAdd);

					If(Random(16)=0)And(j=1)Then
						If(Oct+1 < Octaves Div OctAdd)Then
						Begin
							Inc(Oct);
							Write(f, '>');
							OctAdd := 0; Octaves := 0
						End
						Else If(Oct+1 > Octaves Div OctAdd)Then
						Begin
							Dec(Oct);
							Write(f, '<');
							OctAdd := 0; Octaves := 0
						End;

					If(Value[j]Shr 4)=Oct+1
						Then Write(f, BasicNotes[Value[j]And 15])
						Else Write(f, 'n', (Value[j]Shr 4 - 1)*12 + Value[j]And 15 + 1)
				End
			End;
			If(Round(i) >= Looppaa)And(Loop=0)Then Loop := Row;
			i := i + Spiid;
			If Round(i) >= Riveja Then Break{i := Looppaa}
		End;
		Pause(f, False);
		WriteLn(f, '"');
		If Round(i) >= Riveja Then Break
	Until KeyPressed;

	Write(f, BasicBlock3Txt, Row, BasicBlock4Txt, Loop, BasicBlock6Txt);

	WriteLn('Written TMPTMP.BAS');

	Close(f);
	Assign(f2, CompressorTemp);
	Erase(f2); InOutRes := 0;
	TabFix(f, f2, 'TMPTMP.BAS', 2);
End;

Procedure Kompress(UseLastChan: Boolean); Far;
Var
	f: TDosStream;
	Flush: Boolean;
	Max, b, y: Byte;
	w: Word;
	OutName: String[12];
Begin
	If Debugging Then WriteLn('Compressing to a temporary file ', CompressorTemp);
	OutName := CompressorTemp + #0;
	f.Init(PChar(@OutName)+1, stCreate+stDenyWrite);
	f.Write(Riveja, 2);
	f.Write(Looppaa, 2);

	Max := 3;
	If UseLastChan Then Max := LastChan;

	For y := 0 To Max Do
	Begin
		For w := 0 To Riveja-1 Do
			Laulu^[w][y].Volume := Laulu^[w][y].Volume Shr 2;

		b := 128;
		For w := 0 To Riveja-1 Do
		Begin
			Flush := False;

			If(w=0)Or(b=$FF)Or NoBrains Then Flush := True
			Else If(Laulu^[w][y].Note   <> Laulu^[w-1][y].Note)
					 Or(Laulu^[w][y].Volume <> Laulu^[w-1][y].Volume)Then Flush := True;

			If Flush Then
			Begin
				If b > 128 Then f.Write(b, 1);
				f.Write(Laulu^[w][y], 2);
				b := 128
			End
			Else
				Inc(b)
		End;

		If b>128 Then f.Write(b, 1)
	End;

	Debug('Closing file after compressing.');
	f.Done;

	FileMode := 0
End;

Procedure Show11WriteRiveja(Var f: Text);
Begin
	If Optimizing Then Write(f, Riveja)Else Write(f, 'Riveja')
End;

Procedure Show11WriteLukija(Var f: Text);
Begin
	If Not Optimizing Then
		Write(f,
			'GOSUB Red:a=b:GOSUB Red:','Riveja','=a+b*256'^J,
			'GOSUB Red:a=b:GOSUB Red:','Looppaa','=a+b*256'^J,
			'Rivi=0');

	If Not Optimizing Then Write(f, #10'REDIM Laulu(-1TO Riveja-1,0TO 3)');

	Write(f,
		#10'?"Loading";'' Uncompressing'^J'FOR y=0TO ',
		LastChan,':w=0'^J#9'DO:?STR$((y*');

	Show11WriteRiveja(f);

	Write(f, '+w)*25!\');

	Show11WriteRiveja(f);

	Write(f, ');"%";:LOCATE,9,1:GOSUB Red'^J+
		#9#9'IF b<129THEN j=b:GOSUB Red:Laulu(w,y)=b*256+j:w=w+1 ELSE WHILE '+
		'b>128:Laulu(w,y)=Laulu(w-1,y):w=w+1:b=b-1:WEND'^J#9'LOOP UNTIL w>=');

	Show11WriteRiveja(f);

	WriteLn(f, #10'NEXT')
End;

Procedure Show11;
Var
	y, mo,d,wd: Word;
	h,mi,sec,s100: Word;
	p, q: PChar;
	b: Byte;
	f: Text;
	f2: File;
Begin
	Kompress(Not Optimizing);

	p := strrscan(Name, '\');
	If p = Nil
		Then p := Name
		Else Inc(p);

	q := strrscan(Name, '.');
	If q = Nil Then
		s := strpas(strupper(p))
	Else
	Begin
		s[0] := Chr(q-p);
		For b := 1 To Ord(s[0])Do s[b] := UpCase(p[b-1])
	End;

	For b := 1 To Length(s)Do If s[b]='_' Then Delete(s,b,1);

	If FileLoadDebug Then Debug('Opening output file TMPTMP.BAS');
	Assign(f, 'TMPTMP.BAS');
	ReWrite(f);

	GetDate(y,mo,d,wd);
	GetTime(h,mi,sec,s100);

	Write(f,
		'DEFINT A-Z ''$DYNAMIC'^J+
		'DECLARE SUB WriteR(I,D)'^J+
		'DIM Laulu(-1TO ',Riveja-1,',0TO ',LastChan,
		'),Period(11),D(3),Vol(3),Herz(3)');

	If Not Optimizing Then Write(f, ',Dot(3),N(3)');

	WriteLn(f, #10'?"Generated by ',Title,
		'"'^J'?"Generation time: ',
			d, '.', mo, '.', y, ' ',
			Chr(h Div 10+48), Chr(h Mod 10+48), ':',
			Chr(mi Div 10+48), Chr(mi Mod 10+48), ':',
			Chr(sec Div 10+48), Chr(sec Mod 10+48),
			', file: ', Name, '"'^J+
		'a#=560:FOR y=0TO 11:Period(y)=a#:a#=a#*2^(1/12):NEXT');

	If Optimizing Then
		Show11WriteLukija(f)
	Else
		WriteLn(f, #10'RESTORE ',s,':GOSUB Lue ''The songs are switchable');

	WriteLn(f,
		'P=',TicPeriod, ':',
		'?"done - calibrating delay loop";'^J+
		'Ti#=TIMER:?space$(30);:locate csrlin,pos(0)-30'^J+
		'FOR a#=0TO 999999:IF TIMER-Ti#>2 THEN EXIT FOR'^J+
		'?"";:NEXT:b#=a#\(P*(TIMER-Ti#)):?" -";b#;"loops"'^J);

	If Not Optimizing Then
	Begin
		Write(f,
			''' If someone wants to create an Adlib detection check'^J+
			''' here, it''s ok, but I tried and did not succeed.'^J^J,

			'COLOR 8:?SPACE$(400);:DEF SEG=&HB800'^J+
			'COLOR 7',':?"(Q)uit"',';'^J'y=CSRLIN-4:LOCATE y-1,1:')
	End;

	Write(f,
		'FOR j=0TO 244:WriteR j,0:NEXT',
		#10'?"Using FM synthesis, sampling rate";STR$(P);"Hz"');

	If Optimizing Then Write(f, ':?"(Q)uit"');

	Write(f,
		#10'DO'^J#9'FOR j=0TO ');

	If Optimizing Then Write(f, LastChan)ELse Write(f, '3');

	WriteLn(f,
		#10#9#9'N(j)=Laulu(R,j)AND 15'^J+
		#9#9'IF D(j)THEN Vol(j)=0ELSE Vol(j)=Laulu(R,j)\256');

	If Not Optimizing Then
		WriteLn(f,
			#9#9'COLOR 6+D(j)*2:FOR ny=0TO 3:LOCATE y+ny,1+j*10,0:c$=" ":IF Dot(j)\2>3-',
					'ny THEN c$=""ELSE IF(Dot(j)\2=3-ny)AND(Dot(j)AND 1)THEN c$=""'^J+
			#9#9'?STRING$(6,c$);:NEXT'^J,
			#9#9'IF j<2THEN Dot(j)=Laulu(R,j)\512ELSE IF Laulu(R,j)\256>Laulu(R-1,j)\256',
					'THEN Dot(j)=8ELSE IF Dot(j)>0THEN Dot(j)=Dot(j)-1');

	WriteLn(f,
		#9#9'IF(Laulu(R,j)AND 255)<254THEN Herz(j)=Period(N(j))'^J,
		BasicBlock8Txt,
		#9#9'D0=0:D1=0:D2=0:D3=10:D8=3:D4=240:D5=D4:D10=0:IF j=3THEN O=8ELSE O=j'^J+
		#9#9'IF j<2THEN D2=10:D3=6:D0=1ELSE D10=3:D8=2');

	If(LastChan=3)Or Not Optimizing Then
		WriteLn(f, #9#9'IF j=3THEN D10=15:D3=40:D8=0:D0=3:D1=3:D4=242:D5=D4');

	WriteLn(f,
		#9#9'WriteR 64+O,(D2 AND 192)OR(63-((63-(D2 AND 63))*V/64))'^J+
		#9#9'WriteR 67+O,(D3 AND 192)OR(63-((63-(D3 AND 63))*V/64))'^J+
		#9#9'IF Vol(j)=0THEN'^J+
		#9#9#9'WriteR &HB0+j,0'^J+
		#9#9'ELSE'^J+
		#9#9#9'WriteR 32+O,D0:WriteR 35+O,D1:WriteR 96+O,D4:WriteR 99+O,D5'^J,
		#9#9#9'WriteR &HE0+O,D8:WriteR &HC0+j,D10:WriteR &HA0+j,Herz(j)AND 255'^J+
		#9#9#9'WriteR &HB0+j,32OR((Herz(j)\256)AND 3)OR(1+(Laulu(R,j)AND 255)\16)*4'^J+
		#9#9'ENDIF'^J);

	If Not Optimizing Then
		WriteLn(f,
			#9#9's$="      ":IF Laulu(R,j)\256THEN s$=MID$("A-A#B-C-C#D-D#E-F-F#G-G#",('+
					'N(j))*2+1,2)+LTRIM$(STR$((Laulu(R,j)AND 255)\16))+" "+CHR$((('+
					'Laulu(R,j)\256)*4)\10+48)+CHR$(((Laulu(R,j)\256)*4)MOD 10+48)'^J,
			#9#9'COLOR 7+D(j):LOCATE y+4,41+j*10:?s$;');

	WriteLn(f, #9'NEXT');

	BlankChar := #9;
	If Not Optimizing Then
		WriteLn(f,
			#9'FOR a=0TO 11'^J+
			#9#9'i1=0:i2=2:i3=1'^J+
			#9#9'FOR j=0TO 5'^J+
			#9#9#9'i4=i2:i2=i3:i3=i4'^J+
			#9#9#9'IF j=2THEN i1=1:i2=0:i3=2'^J+
			#9#9#9'IF j=3THEN i1=2:i2=0:i3=1'^J+
			#9#9#9'IF N(i1)=0 THEN'^J,
							'IF N(i2)=':13,3,'AND N(i3)=',6,'THEN s$="dim','":GOTO P'^J,
							'IF N(i2)=':13,4,'AND N(i3)=',8,'THEN s$="aug','":GOTO P'^J,
							'IF N(i2)=':13,4,'AND N(i3)=',9,'THEN s$="6','":GOTO P'^J,
							'IF N(i2)=':13,3,'AND N(i3)=',9,'THEN s$="m6','":GOTO P'^J,
							'IF N(i2)=':13,4,'AND N(i3)=',10,'THEN s$="7','":GOTO P'^J,
							'IF N(i2)=':13,3,'AND N(i3)=',10,'THEN s$="m7','":GOTO P'^J,
							'IF N(i2)=':13,4,'AND N(i3)=',7,'THEN s$="','":GOTO P'^J,
							'IF N(i2)=':13,3,'AND N(i3)=',7,'THEN s$="m','":GOTO P'^J,
			#9#9#9'ENDIF'^J+
			#9#9'NEXT'^J+
			#9#9'FOR j=0TO 3:N(j)=(N(j)+11)MOD 12:NEXT'^J+
			#9'NEXT'^J+
			'P:LOCATE y+4,20'^J+
			#9'IF a<12THEN'^J,
			#9#9'a$="":IF s$<>"aug"THEN a$=RTRIM$(MID$("A A#B C C#D D#E F F#G G#",a*2+1,2))'^J+
			#9#9'?"Sointu=";a$;s$;"    ";'^J+
			#9'ENDIF'^J,

			#9'LOCATE y+4,38,1,13,14'^J+
			#9'FOR ny=1TO 5:FOR j=0TO 79STEP 2'^J+
			#9#9'a=PEEK((ny+y-2)*160+j+40*2):POKE(ny+y-3)*160+j+40*2,a'^J+
			#9'NEXT j,ny');

	BlankChar := ' ';

	Write(f,
		#9'FOR a#=0TO b#:IF TIMER=a#THEN a#=a#'^J#9'NEXT'^J+
		#9'R=R+1:IF R>=');

	Show11WriteRiveja(f);

	Write(f,' THEN R=');

	If Optimizing Then Write(f, Looppaa)Else Write(f, 'Looppaa');

	WriteLn(f,
		#10#9'SELECT CASE INKEY$'^J+
		#9#9'CASE"1":D(0)=1-D(0)'^J+
		#9#9'CASE"2":D(1)=1-D(1)'^J+
		#9#9'CASE"3":D(2)=1-D(2)'^J+
		#9#9'CASE"4":D(3)=1-D(3)'^J+
		#9#9'CASE"":'^J,
		#9#9'CASE"Q","q":EXIT DO'^J+
		#9'END SELECT'^J+
		'LOOP'^J,
		'FOR j=0TO 244:WriteR j,0:NEXT',
		#10'?:SYSTEM'^J);

	Write(f, BasicBlock7Txt, BasicBlock6Txt);

	Debug('Reading the temporary file.');

	Assign(f2, CompressorTemp);
	Reset(f2, 1);

	If Optimizing Then
		Seek(f2, 4)
	Else
	Begin
		WriteLn(f, 'Lue:');
		Show11WriteLukija(f);
		WriteLn(f, BasicBlock6Txt, s,':'#9''' ',PChar(@Hdr))
	End;

	y := 0;
	d := 1;
	While Not Eof(f2)Do
	Begin
		BlockRead(f2, b, 1, h);
		If h=0 Then Break;
		If y>29 Then Begin WriteLn(f, ',',d:3,',',mo); Inc(d); y := 0 End;
		If y=0 Then Begin mo := 0; Write(f, 'DATA ')End;
		Inc(mo, b);
		Write(f, BHex(b));
		Inc(y)
	End;

	WriteLn(f, #10^J+
		'SUB WriteR(I%,D%)'^J+
		#9'OUT&H388,I%:a%=INP(&H388):OUT&H389,D%:a%=INP(&H388)'^J+
		'END SUB'^J);

	Debug('Closing files');
	Close(f);
	Close(f2);
	Erase(f2);
	TabFix(f, f2, 'TMPTMP.BAS', 2);

	WriteLn('Written TMPTMP.BAS')
End;

Function ModRM(s: PChar): Integer;
Var i: Integer;
Begin
	i := 1;
	Case Ord(s^)And $C0 Of
		$00: If(Ord(s^)And 7)=6 Then Inc(i, 2);
		$40: Inc(i);
		$80: Inc(i, 2);
		$C0: ;
	End;
	ModRM := i
End;

Procedure PasComRead(Var f: Text; Var q: PChar; Indent: Integer; Reg: Char);
Var i: Integer; Sign: Boolean;
Begin
	While q^ = ' ' Do Inc(q);

	If q^ = 'a' Then Exit;

	Write(f, #9,'':Indent);

	Case q^ Of
		'&':
		Begin
			Write(f, 'mov ax, 40h'^J#9,      '':Indent);
			Write(f, 'push ds'^J#9,          '':Indent);
			Write(f, ' mov al, ds:[6Ch]'^J#9,'':Indent);
			Write(f, ' and ax, 15'^J#9,      '':Indent);
			Write(f, 'pop ds')
		End;
		'l': Begin Write(f, 'mov ',Reg,'l, IRQProblem'^J#9,'':Indent,'xor ',Reg,'h, ',Reg,'h')End;
		'*': Begin Write(f, 'mov ',Reg,'l, [si]'^J#9,      '':Indent,'xor ',Reg,'h, ',Reg,'h')End;
		'i': Write(f, 'mov ',Reg,'x, IRQCounter');
		'r': Write(f, 'mov ',Reg,'x, Riveja');
		'p': Write(f, 'mov ',Reg,'x, si');
		'w': Write(f, 'mov ',Reg,'x, w');
		'y': Write(f, 'mov ',Reg,'x, y');
		'b': Begin Write(f, 'mov ',Reg,'l, b'^J#9,         '':Indent,'xor ',Reg,'h, ',Reg,'h')End;
		Else
			If(q^ <> '-')And((q^ < '0')Or(q^ > '9'))Then
			Begin
				WriteLn('Unknown variable: ', q);
			End;
			i := 0;
			Sign := False;
			Repeat
				If q^ = '-' Then Sign := True
				Else If q^ <> '+' Then Break;
				Inc(q)
			Until False;
			While(q^ >= '0')And(q^ <= '9')Do
			Begin
				i := i*10 + Ord(q^)-Ord('0');
				Inc(q)
			End;
			If Sign Then i := -i;
			If i=0
				Then Write(f, 'xor ',Reg,'x, ',Reg,'x')
				Else Write(f, 'mov ',Reg,'x, ',i)
	End;

	WriteLn(f)
End;

Procedure Ehto(Var f: Text; Var q: PChar; Indent: Integer; Inverse: Boolean);
Var Equ: Integer;
Begin
	PasComRead(f, q, Indent, 'd');
	Repeat Inc(q)Until q^ <> ' ';
	{=0 ==0 <=1 =<1 >=2 =>2 <>3 !=3 <4 >5}
	Case q^ Of
		'=':
		Begin
			Inc(q);
			Case q^ Of
				'=': Begin Inc(q); Equ := 0 End;
				'<': Begin Inc(q); Equ := 1 End;
				'>': Begin Inc(q); Equ := 2 End;
				Else Equ := 0
			End
		End;
		'!':
		Begin
			Inc(q);
			Case q^ Of
				'=': Begin Inc(q); Equ := 3 End;
			End
		End;
		'>':
		Begin
			Inc(q);
			Case q^ Of
				'=': Begin Inc(q); Equ := 2 End;
				'<': Begin Inc(q); Equ := 3 End;
				Else Equ := 5
			End
		End;
		'<':
		Begin
			Inc(q);
			Case q^ Of
				'=': Begin Inc(q); Equ := 1 End;
				'>': Begin Inc(q); Equ := 3 End;
				Else Equ := 4
			End
		End;
	End;
	Inc(q);
	PasComRead(f, q, Indent, 'a');
	Write(f, #9,'':Indent,'cmp dx, ax'^J#9,'':Indent);

	If Inverse Then
		If(Equ=0)Or(Equ=3)
			Then Equ := 3-Equ
			Else Equ := 6-Equ;

	Case Equ Of
		0: Write(f, 'je');
		1: Write(f, 'jbe');
		2: Write(f, 'jae');
		3: Write(f, 'jne');
		4: Write(f, 'jb');
		5: Write(f, 'ja')
	End
End;

Procedure PasComUse(Var f: Text; Ch: Char);
Begin
	Case Ch Of
		'a': Write(f, 'ax');
		'b': Write(f, 'b');
		'w': Write(f, 'w');
		'y': Write(f, 'y');
		'p': Write(f, 'si');
		'i': Write(f, 'IRQCounter');
		'l': Write(f, 'IRQProblem');
		'*': Write(f, 'byte ptr [si]')
	End
End;

Procedure PasComStore(Var f: Text; Indent: Integer; Ch: Char);
Begin
	If Ch <> 'a' Then Write(f, #9,'':Indent,'mov ');
	Case Ch Of
		'b': Write(f, 'b, al');
		'w': Write(f, 'w, ax');
		'y': Write(f, 'y, ax');
		'p': Write(f, 'si, ax');
		'i': Write(f, 'IRQCounter, ax');
		'l': Write(f, 'IRQProblem, al');
	End;
	If Ch <> 'a' Then WriteLn(f)
End;

Procedure PasComCode(Var f: Text; Var s: PChar; Var Labeli: Integer; EndLoc: Integer);
Var
	Buf: Array[0..63]Of Char;
	Loc1, Loc2, Indent: Integer;
	TmpB, UseampiEhto: Boolean;
	q, q1, q2: PChar;
	Ch: Char;
Begin
	While s^ <> #0 Do
	Begin
		q := Buf;
		While s^ <> #10 Do Begin q^ := s^; Inc(q); Inc(s)End;
		q^ := #0;
		q := Buf;
		Inc(s);

		Indent := 0;
		While q^ = ' ' Do Begin Inc(Indent); Inc(q)End;
		q1 := q; {Tss vaiheessa s osoittaa seuraavaan komentoon}

		Ch := q^;
		Case Ch Of
			'^':
			Begin
				Loc1 := Labeli; Inc(Labeli);
				Loc2 := Labeli; Inc(Labeli);
				WriteLn(f, '@@',Loc1,':'#9,'':Indent,'; loop-start');
				PasComCode(f, s, Labeli, Loc2);
				WriteLn(f,
					#9,'':Indent,'jmp @@',Loc1,#10'@@',Loc2,':'#9,
						 '':Indent,'; loop-end')
			End;
			'?':
			Begin
				Inc(q);
				q2 := q;
				While q2^ = ' ' Do Inc(q2);

				UseampiEhto := StrScan(q, '|') <> Nil;

				Loc1 := Labeli; Inc(Labeli);
				If UseampiEhto Then
				Begin
					Loc2 := Labeli;
					Inc(Labeli)
				End;

				Repeat
					TmpB := StrScan(q, '|') = Nil;
					Ehto(f, q, Indent, TmpB);
					Write(f, ' @@');
					If TmpB
						Then Write(f, Loc1)
						Else Write(f, Loc2);
					WriteLn(f, #9#9#9'; If ',q2);
					While q^ = ' ' Do Inc(q);
					If q^ = #0 Then Break;
					Inc(q) {Assume q^ = '|'}
				Until False;

				If UseampiEhto Then Write(f, '@@',Loc2,':');
				PasComCode(f, s, Labeli, EndLoc);
				WriteLn(f, '@@',Loc1,':'#9,'':Indent,'; end-if')
			End;
			'<':
			Begin
				Inc(q);
				Ehto(f, q, Indent, False);
				WriteLn(f, ' @@',EndLoc)
			End;
			'$': Break;
			'-', '+':
			Begin
				Write(f, #9,'':Indent);
				If Ch='-'
					Then Write(f, 'dec ')
					Else Write(f, 'inc ');
				Inc(q);
				PasComUse(f, q^);
				WriteLn(f)
			End;
			'o':
			Begin
				Inc(q);
				While q^ = ' ' Do Inc(q);
				Write(f, #9,'':Indent,'mov al, ');
				While q^ <> ' ' Do
				Begin
					Write(f, q^);
					Inc(q)
				End;
				While q^ = ' ' Do Inc(q);
				Write(f, #10#9,'':Indent,'out ');
				While q^ <> ' ' Do
				Begin
					If q^ = #0 Then Break;
					Write(f, q^);
					Inc(q)
				End;
				WriteLn(f, ', al')
			End;
			'#':
			Begin
				Inc(q);
				While q^ = ' ' Do Inc(q);
				WriteLn(f, #9,'':Indent, q)
			End;
			'b','w','y','a','p','*','i','l':
			Begin
				Inc(q);
				While q^ = ' ' Do Inc(q);
				If q^ = '<' Then
				Begin
					Inc(q);
					PasComRead(f, q, Indent, 'c');
					Write(f, #9,'':Indent,'shl ');
					PasComUse(f, Ch);
					WriteLn(f, ', cl')
				End
				Else
				Begin
					PasComRead(f, q, Indent, 'a');
					PasComStore(f, Indent, Ch)
				End
			End;
			'R', 'S':
			Begin
				Inc(q);

				WriteLn(f, #9,'':Indent,'push ax');
				Inc(Indent);

				PasComRead(f, q, Indent, 'c');
				WriteLn(f,#9,'':Indent,'add cx, w'^J#9,
										 '':Indent,'shl cx, 3'^J#9,
										 '':Indent,'mov ax, y'^J#9,
										 '':Indent,'add ax, ax');
				PasComRead(f, q, Indent, 'b');
				WriteLn(f, #9,'':Indent,'add bx, ax'^J#9,
											'':Indent,'add bx, cx');

				Dec(Indent);
				WriteLn(f, #9,'':Indent,'pop ax');

				If Ch = 'S' Then
				Begin
					PasComRead(f, q, Indent, 'a');

					WriteLn(f, #9,'':Indent,'mov es:[bx], al');
				End
				Else
				Begin
					WriteLn(f, #9,'':Indent,'mov al, es:[bx]'^J#9,
												'':Indent,'xor ah, ah');
					While q^ = ' ' Do Inc(q);
					PasComStore(f, Indent, q^)
				End;
				WriteLn(f)
			End
		End
	End
End;

Procedure PasCom(Var f: Text; Const s: String);
Var Lab: Integer; q: PChar;
Begin
	Lab := 1;
	q := PChar(@s[1]);
	PasComCode(f, q, Lab, 0);
	Writeln(f, '@@0:')
End;

Procedure NesMusa4WriteStr(Size:Word; Str: PChar); Far;
Const CR: Char = #13;
Begin
	While Size > 0 Do
	Begin
		If Str^ = #10 Then CrtOldWrite(1, @CR);
		CrtOldWrite(1, Str);
		Inc(Str);
		Dec(Size)
	End;
End;

Procedure Show8;
Var
	Buf: Array[0..255]Of Char;
	BufPtr, BRead, a: Word;
	Quote: Boolean;
	p, q: PChar;
	fn: String;
	f2: File;
	f: Text;
	b: Byte;

	y,mo,d,wd: Word;
	h,mi,sec,s100: Word;
Begin
	CrtLocal.WriteStrProcAddr := NesMusa4WriteStr;
	{---}

	p := strrscan(Name, '\');
	If p = Nil
		Then p := Name
		Else Inc(p);

	q := strrscan(Name, '.');
	If q = Nil Then
		s := strpas(strupper(p))
	Else
	Begin
		s[0] := Chr(q-p);
		For a := 1 To Ord(s[0])Do s[a] := UpCase(p[a-1])
	End;

	fn := s + '.ASM';

	Kompress(True);
	Assign(f2, CompressorTemp);
	Reset(f2, 1);

	If Debugging Then WriteLn('Opening ',fn);
{	AssignCrt(f);}
	Assign(f, fn);
	ReWrite(f);

	For b := 0 To 2 Do
		WriteLn(f,
			'b',b,#9'equ (byte ptr ',b,')'^J+
			'w',b,#9'equ (word ptr ',b,')');

	GetDate(y,mo,d,wd);
	GetTime(h,mi,sec,s100);

	WriteLn(f,
		'ofs'#9'equ w0'^J'seg'#9'equ w2'^J+

		'jumps'^J+
		'locals @@'^J^J+
		'code'#9'segment'#9'byte public use16'^J+
		#9'assume cs:code,ds:code'^J+
		#9'.8086'^J+
		#9'org 100h'^J+
		'Stub:'+
		#9'mov ax, cs'^J+
		#9'mov ds, ax'^J+
		#9'mov PrefixSeg, ax'^J,
		#9'mov es, ax'^J+
		#9'mov ah, 4Ah'^J+
		#9'mov bx, 1000h'^J+
		#9'int 21h'#9'; Need only 64k'^J,

		#9'mov dx, offset Txt00',#10#9'mov ah, 9'^J#9'int 21h'^J,
		#9'call _Init'^J+
		#9'call _Start'^J,
		#9'mov dx, offset Txt02',#10#9'mov ah, 9'^J#9'int 21h'^J,
		#9'xor ax, ax'#9'; The music is playing on the background;'^J+
		#9'int 16h'#9#9'; the program could do anything else here.'^J+
		#9'mov dx, offset Txt03'^J,
		'TxtTrm:',
		#9'push dx'^J+
		#9' call _End'^J+
		#9'pop dx'^J,            #10#9'mov ah, 9'^J#9'int 21h'^J,
		#9'mov ax, 4C00h'^J+
		#9'int 21h'^J^J,

		'BasePort     dw 0',WHex(BasePort),'h'^J+
		'IRQ'#9'     db ',IRQ,
		#10'GlobalVolume db ',GlobalVolume,
		#10'Period       dw 907,960,1016,1076,1140,1208,1280,1356,1440,1524,1616,1712'+
		#10'Rate       = ',Rate,
		#10'Riveja     = ',Riveja,
		#10'Looppaa    = ',Looppaa,
		#10'TicLen     = Rate / ',TicPeriod,
		#10'Pitch        dw ',Rate,
		#10'PrefixSeg    dw ?'^J+
		'SampleSize   dw ?'^J+
		'TimeConst    db ?'^J+
		'PlayBuf      dd 0'^J+
		'SmpBuf'#9'     dd 0'^J+
		'Cache'#9'     dd 0'^J^J,

		'txt00'#9'db "Generated by ',Title,                           '",13,10'^J+
		#9'db "Generation time: ',d,'.',mo,'.',y,' ',
			Chr(h Div 10+48),Chr(h Mod 10+48),':',
			Chr(mi Div 10+48),Chr(mi Mod 10+48),':',
			Chr(sec Div 10+48),Chr(sec Mod 10+48),', file: ',Name,      '",13,10,"$"'^J,
		'txt01'#9'db "Nobody is perfect. Memory allocation error.',   '",13,10,"$"'^J,
		'txt02'#9'db "Press a key',                                   '",13,10,"$"'^J,
		'txt03'#9'db "Ending',                                        '",13,10,"$"'^J,

		#10's1'#9'     dd 0');

	If LastChan >= 2 Then WriteLn(f,    's2'#9'     dd 0');
	If LastChan >= 3 Then WriteLn(f, #10's3'#9'     dd 0'^J);

	WriteLn(f,
		'IRQCounter   dw ?'^J+
		'Rivi'#9'     dw 0'^J+
		'TicCount     dw ?'^J+
		'IRQProblem   db 0'^J+
		'No_EOI       db ?'^J,
		'Volume       db ',LastChan+1,' dup (?)'^J,
		'Pos'#9'     dd ',LastChan+1,' dup (?)'^J,
		'Herz'#9'     dd ',LastChan+1,' dup (?)'^J,
		'OldI0D'#9'     dd ?'^J+
		'TimerPtr     dd 0040006Ch'^J+
		'Int8Vec      dd 8 * 4'^J+
		'Laulu'#9'     dd 0'^J^J+
		'y dw ?'^J'w dw ?'^J'b db ?'^J,

		#10'_Start:',
		#9'les di, Int8Vec'^J,
		#9'mov ax, es:[di].Ofs'^J#9'mov OldI08.Ofs, ax'^J,
		#9'mov ax, es:[di].Seg'^J#9'mov OldI08.Seg, ax'^J,
		#9'mov bx, 8'^J+
		#9'add bl, IRQ'^J+
		#9'shl bx, 2'^J,
		#9'mov ax, es:[bx].Ofs'^J#9'mov OldI0D.Ofs, ax'^J,
		#9'mov ax, es:[bx].Seg'^J#9'mov OldI0D.Seg, ax'^J,
		#9'push es'^J+
		#9' push bx'^J+
		#9'  call InitDSP'^J+
		#9' pop bx'^J+
		#9'pop es'^J,
		#9'mov No_EOI, 0'^J,
		#9'mov es:[bx].w2, cs'^J+
		#9'mov es:[bx].w0, offset NewI0D'^J^J,

		#9'mov ax, 1000h'#9#9'; 64kbytes'^J+
		#9'call GetPages'^J+
		#9'mov PlayBuf.Seg, ax'^J,

		#9'add ax, 0FFFh'^J+
		#9'and ax, 0F000h'^J+
		#9'xor dx, dx'^J+
		#9'mov SmpBuf.Ofs, dx'^J+
		#9'mov SmpBuf.Seg, ax'^J,

		#9'sub ax, PlayBuf.Seg'^J+
		#9'shl ax, 4'^J+
		#9'mov SampleSize, 65520'^J+
		#9'sub SampleSize, ax'^J,

		#9'mov ax, PlayBuf.Seg'^J+
		#9'mov SmpBuf.Seg, ax'^J,
		#9'mov ax, 65520'^J+
		#9'sub ax, SampleSize'^J+
		#9'mov SmpBuf.Ofs, ax'^J,

		#9'xor dx, dx'^J+
		#9'mov ax, SampleSize'^J+
		#9'mov bx, TicLen'^J+
		#9'div bx'^J+
		#9'mov TicCount, ax'#9#9'; Bytes in one tick'^J+
		#9'mul bx'^J+
		#9'mov SampleSize, ax'^J,

		#9'call GetMem'^J+
		#9'mov Cache.Seg, ax'^J,

		#9'call InitInstrus'^J^J,

		#9'les di, SmpBuf'^J+
		#9'mov cx, SampleSize'^J,
		#9'xor al, al'^J+
		#9'push cx'^J+
		#9' rep stosb'^J+
		#9' les di, Cache'^J+
		#9'pop cx'^J,
		#9'rep stosb'^J+
		#9'push SmpBuf.Seg'^J,
		#9' push SmpBuf.Ofs'^J,
		#9'  call Palanen'^J+
		#9'mov al, 0D0h'^J+
		#9'call WriteDSP'^J+
		#9'mov Rivi, 0'^J,

		#9'call CallIRQ'^J,
		#9'call CallIRQ'^J,

		#10#9'les di, Int8Vec'^J+

		#9'cli'^J+
		#9'mov es:[di].Ofs, offset NewI08'^J+
		#9'mov es:[di].Seg, cs'^J,
		#9'sti',
		#10#9'retn'^J,

		#10'CallIRQ:'^J,
		#9'mov al, cs:IRQ'^J+
		#9'add al, 8'^J+
		#9'mov byte ptr cs:[offset @@I], al'^J+
		#9'db 0CDh'^J+
		'@@I:'#9'db 0',
		#10#9'retn'^J,

		#10'InitInstrus:'^J,

		#9'mov ax, 4096*2'^J+
		#9'call GetMem'^J+
		#9'mov s','1.Seg, ax');

	If LastChan >= 2 Then
		WriteLn(f, #9'mov ax, 4096*2'^J+
							 #9'call GetMem'^J+
							 #9'mov s','2.Seg, ax');

	If LastChan >= 3 Then
		WriteLn(f, #9'mov ax, 4096*2'^J+
							 #9'call GetMem'^J+
							 #9'mov s','3.Seg, ax');

	WriteLn(f,
		#9'xor bx, bx'^J,
		'@@5:',
		#9'mov ax, 8000'^J+
		#9'cmp bx, 1024'^J+
		#9'jb @@1'^J+
		#9'mov ax, 1000'^J,
		'@@1:',
		#9'mov es, s1.Seg'^J+
		#9'mov si, bx'^J+
		#9'mov es:[bx+si], ax');

	If LastChan >= 2 Then
		WriteLn(f, #10,
			#9'mov ax, 5'^J+
			#9'mov cx, bx'^J+
			#9'cmp bx, 2048'^J+
			#9'jae @@3'^J,
			'@@2:',
			#9'mul cx'^J+
			#9'jmp @@4'^J,
			'@@3:',
			#9'sub cx, 4095'^J+
			#9'neg cx'^J+
			#9'jmp @@2'^J,
			'@@4:',
			#9'mov es, s2.Seg'^J+
			#9'mov si, bx'^J+
			#9'mov es:[bx+si], ax');

	If LastChan >= 3 Then
		WriteLn(f, #10,
							 #9'call Rand10k'^J+
							 #9'mov es, s3.Seg'^J+
							 #9'mov si, bx'^J+
							 #9'mov es:[bx+si], ax');

	WriteLn(f,#10#9'inc bx'^J+
						 #9'cmp bx, 4096'^J+
						 #9'jb @@5'^J,
						 #10#9'retn');

	If LastChan >= 3 Then
		WriteLn(f, #10'Rand10k:'^J+
							 #9'mov ax, 19356'^J+
							 #9'mul di'^J+
							 #9'add di, 13556'^J+
							 #9'xor di, cs:[bx]'^J+
							 #9'add di, dx'^J^J+
							 #9'xor dx, dx'^J+
							 #9'mov cx, 10000'^J+
							 #9'div cx'^J+
							 #9'mov ax, dx'^J,
							 #10#9'retn');

	WriteLn(f, #10'_Init:',
		#9'mov ax, Riveja*8'^J+
		#9'call GetMem'^J+
		#9'mov Laulu.Seg, ax'^J^J,
		#9'cld'^J+

		#9'mov si, offset PackedSong'^J+
		#9'mov es, Laulu.Seg'^J);

	PasCom(f,
		'y 0'^J+
		'^'^J+
		' w 0'^J+
		' ^'^J+
		'  b *'^J+
		'  +p'^J+

		'  ? b <= 128'^J+
		'   a *'^J+
		'   +p'^J+
		'   a < 2'^J+
		'   S 0 1 a'^J+
		'   S 0 0 b'^J+
		'   +w'^J+
		'  $'^J+

		'  ? b > 128'^J+
		'   ^'^J+
		'    < b <= 128'^J+
		'    R -1 0 a'^J+
		'    S  0 0 a'^J+
		'    R -1 1 a'^J+
		'    S  0 1 a'^J+
		'    +w'^J+
		'    -b'^J+
		'   $'^J+
		'  $'^J+
		'  < w >= r'^J+
		' $'^J+
		' < y = '+Chr(LastChan+48)+#10+
		' +y'^J+
		'$'^J+
		'$'^J#0);

	WriteLn(f, #10#9'retn');

	Writeln(f, #10'_End:',
		#9'mov bx, 8'^J+
		#9'add bl, IRQ'^J+
		#9'shl bx, 2'^J+
		#9'les di, Int8Vec'^J+

		#9'mov ax, OldI0D.Ofs'^J#9'mov es:[bx].Ofs, ax'^J+
		#9'mov ax, OldI0D.Seg'^J#9'mov es:[bx].Seg, ax'^J,

		#9'mov ax, OldI08.Ofs'^J#9'mov es:[di].Ofs, ax'^J+
		#9'mov ax, OldI08.Seg'^J#9'mov es:[di].Seg, ax'^J,

		#9'mov es, Cache','.Seg'^J+
		#9'mov ah, 49h'^J+
		#9'int 21h'^J,

		#9'mov es, Playbuf','.Seg'^J+
		#9'mov ah, 49h'^J+
		#9'int 21h');

	If LastChan >= 3 Then
		WriteLn(f,
			#9'mov es, s3','.Seg'^J+
			#9'mov ah, 49h'^J+
			#9'int 21h');

	If LastChan >= 2 Then
		WriteLn(f,
			#9'mov es, s2','.Seg'^J+
			#9'mov ah, 49h'^J+
			#9'int 21h');

	WriteLn(f,
		#9'mov es, s1','.Seg'^J+
		#9'mov ah, 49h'^J+
		#9'int 21h'^J,

		#9'call DoneDSP',
		#10#9'retn'^J,

		#10'GetMem:'+
		#9'add ax, 15'^J+
		#9'shr ax, 4'^J+
		'GetPages:'#9#9'; External entry'^J+
		#9'xchg bx, ax'^J+
		#9'mov ah, 48h'^J+
		#9'int 21h'^J+
		#9'cmp ax, 7'^J+
		#9'je @@1',
		#10#9'retn'^J,
		'@@1:',
		#9'mov dx, offset txt01'^J+
		#9'jmp TxtTrm'^J,

		#10'Palanen:'^J+
		#9'Dest equ (dword ptr [bp+4])'^J+
		#9'j equ (byte ptr [bp-2])'^J+
		#9'k equ (word ptr [bp-4])'^J+
		#9'l equ (word ptr [bp-6])'^J+
		#9'p equ (dword ptr [bp-10])'^J+

		#9'push bp'^J+
		#9'mov bp, sp'^J+
		#9'sub sp, 10'^J,

		#9'mov ax, Dest.w0'^J+
		#9'mov p.w0, ax'^J+
		#9'mov ax, Dest.w2'^J+
		#9'mov p.w2, ax'^J^J,

		#9'mov l, 0'^J,
		'@@1:',
		#9'mov word ptr j, 0'^J,
		'@@2:',
		#9'mov bx, word ptr j'^J+
		#9'mov si, bx'^J+
		#9'mov di, Rivi'^J+
		#9'shl di, 3'^J+
		#9'mov es, Laulu.Seg'^J+
		#9'add di, si'^J+
		#9'mov ax, es:[di+bx]'^J,
		#9'mov byte ptr Volume[bx], ah'^J,
		#9'cmp al, 254'^J+
		#9'jae @@3'^J,
		#9' mov cl, al'^J+
		#9' shr cl, 4'^J+
		#9' and ax, 15'^J+
		#9' add ax, ax'^J+
		#9' mov bx, ax'^J,
		#9' mov ax, word ptr Period[bx]'^J+
		#9' shl ax, cl'^J+
		#9' mul Pitch'^J+
		#9' mov si, word ptr j'^J+
		#9' mov cx, 22050'^J+
		#9' div cx'^J+
		#9' shl si, 2'^J+
		#9' mov Herz[si].w0, ax'^J+
		#9' xor ax, ax'^J+
		#9' mov Herz[si].w2, ax'^J,
		'@@3:',
		#9'inc j'^J+
		#9'cmp j, 3'^J+
		#9'jbe @@2'^J^J,

		#9'mov k, TicLen'^J,
		'@@4:',
		#9'dec k'^J^J+

			#9'db 66h'^J#9'xor cx, cx'^J+
			#9'mov di, ',LastChan,
		#10'@@MixNextChan:'^J+
			#9'mov bx, di'^J,
			#9'mov al, byte ptr Volume[di]'^J+
			#9'cbw'^J+
			#9'or al, al'^J+
			#9'jz @@MuteChan'^J+
			#9'add bx, bx'^J,
			#9'add bx, bx'^J+
			#9'mov ax, Herz[bx].w0'^J+
			#9'mov dx, Herz[bx].w2'^J+
			#9'add Pos[bx].w0, ax'^J+
			#9'adc Pos[bx].w2, dx'^J+
			#9'mov ax, Pos[bx].w1');

	If LastChan >= 3 Then
		WriteLn(f, #9'les si, s3'^J,
							 #9'cmp di, 3'^J,
							 #9'je @@MixMelody');

	If LastChan >= 2 Then
		WriteLn(f, #9'les si, s2'^J+
							 #9'cmp di, 2'^J+
							 #9'je @@MixMelody');

	WriteLn(f,
			#9'les si, s1'^J,
			#9'jmp @@MixMelody'^J,
		'@@MixMelody:'^J+
			#9'and ax, 4095'^J+
			#9'add ax, ax'^J+
			#9'add si, ax'^J+
			#9'mov ax, es:[si]'^J,
			#9'mov bl, byte ptr Volume[di]'^J,
			#9'xor bh, bh'^J,
			#9'mul bx'^J,
			#9'db 66h,0C1h,0E2h,16'#9'; shl edx, 16'^J+
			#9'mov dx, ax'^J,
			#9'db 66h'^J#9'add cx, dx'^J,
		'@@MuteChan:'^J,
			#9'dec di'^J,
			#9'jns @@MixNextChan'^J,
			#9'les di, p'^J,
			#9'db 66h,0C1h,0E9h,5'#9'; shr ecx, 5'^J+
			#9'mov byte ptr es:[di], ch'^J,
			#9'inc word ptr p'^J^J,

		#9'cmp k, 0'^J+
		#9'ja @@4'^J^J+

		#9'inc Rivi'^J+
		#9'cmp Rivi, Riveja'^J+
		#9'jb @@5'^J+
		#9'mov Rivi, Looppaa'^J,
		'@@5:'^J,
		#9'inc l'^J+
		#9'mov ax, TicCount'^J+
		#9'cmp l, ax'^J+
		#9'jb @@1'^J^J,

		#9'mov sp, bp'^J+
		#9'pop bp'^J+
		#9'retn 4'^J,

		#10'NewI08:',
		#9'push ax'^J#9'push bx'^J#9'push cx'^J#9'push dx'^J+
		#9'push si'^J#9'push di'^J#9'push ds'^J#9'push es'^J+
		#9'push cs'^J#9'pop ds');

	PasCom(f,
		'? i < 999'^J+
		' +i'^J+
		'$'^J+
		'? l <> 0'^J+
		' ? i < 999'^J+
		'  ? i > 127'^J+
		'   i 999'^J+
		'  $'^J+
		' $'^J+
		'$'^J+

		'? i = 91 | i > 140'^J+
		' l 1'^J+
		' ? i < 999 | & = 0'^J+
		'  # call InitDSP'^J+
		'  # mov No_EOI, 1'^J+
		'  # call CallIRQ'^J+
		'  # mov No_EOI, 0'^J+
		' $'^J+
		'$'^J+
		'$'^J);

	WriteLn(f,
		#9'pop es'^J#9'pop ds'^J#9'pop di'^J#9'pop si'^J+
		#9'pop dx'^J#9'pop cx'^J#9'pop bx'^J#9'pop ax'^J,
		#9'db 0EAh'^J+
		'OldI08'#9'dd ?');

	WriteLn(f,
		#10'NewI0D:',
		#9'cld'^J,
		#9'push ax'^J#9'push bx'^J#9'push cx'^J#9'push dx'^J+
		#9'push si'^J#9'push di'^J#9'push ds'^J#9'push es'^J+
		#9'push cs'^J#9'pop ds'^J,
	{...}
		#9'mov dx, BasePort'^J,
		#9'add dx, 14'^J+
		#9'in al, dx'^J+
		#9'sub dx, 4'^J+
		#9'in al, dx'^J,

		#9'cmp No_EOI, 0'^J+
		#9'jnz @@1'^J+
		#9' mov IRQCounter, 0'^J+
		#9' mov IRQProblem, 0'^J,
		'@@1:',

		#9'mov dx, 15'#9'; 1000000'^J+
		#9'mov ax, 4240h'^J+
		#9'div Pitch'^J+
		#9'sub ax, 256'^J+
		#9'neg ax'^J+
		#9'mov TimeConst, al'^J,

		#9'mov cx, SampleSize;'^J+
		#9'push ds'^J+
		#9' les di, SmpBuf'^J+
		#9' lds si, Cache'^J+
		#9' rep movsb'^J+
		#9'pop ds'^J,

		#9'mov bx, SmpBuf.Seg'^J+
		#9'mov dx, bx'^J+
		#9'shl bx, 4'^J+
		#9'shr dx, 12'^J,
		#9'add bx,word ptr SmpBuf'^J#9'adc dx, 0'^J#9'mov cx, SampleSize;');

	PasCom(f, AsmBlock1Txt);

	WriteLn(f,
		#9'mov al, 64'^J,                      #9'call WriteDSP'^J,
		#9'mov al, TimeConst'^J,               #9'call WriteDSP'^J,
		#9'mov al, 20'^J,                      #9'call WriteDSP'^J,
		#9'mov al, SampleSize.b0'^J,           #9'call WriteDSP'^J,
		#9'mov al, SampleSize.b1'^J,           #9'call WriteDSP'^J,
		#9'push Cache.Seg'^J+
		#9' push Cache.Ofs'^J+
		#9'  call Palanen'^J,
		#9'in al, 21h'^J+
		#9'mov ah, 1'^J+
		#9'mov cl, IRQ'^J+
		#9'shl ah, cl'^J+
		#9'not ah'^J,
		#9'and al, ah'^J+
		#9'out 21h, al'^J+
		#9'cmp No_EOI, 0'^J+
		#9'jnz @@2'^J+
		#9'mov al, 20h'^J+
		#9'out 020h, al'^J+
		#9'out 0A0h, al'^J,
		'@@2:'^J,
		#9'pop es'^J#9'pop ds'^J#9'pop di'^J#9'pop si'^J+
		#9'pop dx'^J#9'pop cx'^J#9'pop bx'^J#9'pop ax'^J,
		#9'iret');

	WriteLn(f, #10'WriteDSP:', #9'; Dis-assembled'); DASM(f, @_WriteDSP, True);
	WriteLn(f, #10'BitDelay:', #9'; Dis-assembled'); DASM(f, @_BitDelay, True);
	WriteLn(f, #10'InitDSP:',  #9'; Dis-assembled'); DASM(f, @_InitDSP, True);
	WriteLn(f, #10'DoneDSP:',  #9'; Dis-assembled'); DASM(f, @_DoneDSP, True);

	WriteLn(f, #10'PackedSong: ; ','Compressor is the same as in the OBJ save of NESMUSA');

	Debug('Writing the packed song');

{
	11.6.1998 00:20 Bisqwit

	Katselin parvekkeelta ulos. Oli pime, kosteaa ja lmmint.
	Katuvalaistus ei ollut pll. S-marketin parkkitalon katolla tosin
	oli valot pll. Katselin parvekkeelta ymprilleni sille 170
	alueelle, mille sielt nkee. Laskin, nin 10 radiomastoa. Tai niiden
	valoa itse asiassa. Ja yhden maston, jossa vilkkuu valkoinen valo.
	Nkym oli niin mahtava, ett olisi tosiaan tehnyt mieli osata
	lent niin kuin Peter Pan.
}

	a := 0;
	Seek(f2, 4);
	While Not Eof(f2)Do
	Begin
		If a=18 Then
		Begin
			If Quote Then Write(f, '''');
			WriteLn(f); a := 0
		End;
		If a=0 Then
		Begin
			Quote := False;
			Write(f, #9'db'#9)
		End;
		BlockRead(f2, b, 1);
		If(((b >= 32)And(b < 126))Or((b>=128)And(b<250)))And(b <> $27)Then
		Begin
			If Not Quote Then
			Begin
				If a > 0 Then Write(f, ',');
				Write(f, '''')
			End;
			Write(f, Chr(b));
			Quote := True
		End
		Else
		Begin
			If Quote Then Write(f, '''');
			If a > 0 Then Write(f, ',');
			Write(f, b);
			Quote := False
		End;

		Inc(a)
	End;

	If Quote Then Write(f, '''');

	WriteLn(f, #10#10'code'#9'ends'^J#9'end'#9'Stub');

	Debug('Closing files');
	Close(f2);
	Erase(f2);
	Close(f);

	TabFix(f, f2, fn, 8);

	WriteLn(
		'Written ',fn,
		#13^J'Notice: Sometimes the programs generated with -A switch'+
		#13^J'cause a divide overflow. I haven''t yet found the reason.')
End;

Function WHex(w: Word): PChar;
Const Buf: Array[0..4]Of Char = '';
Begin
	Buf[0] := HC[WordRec(w).Hi Shr 4];
	Buf[1] := HC[WordRec(w).Hi And 15];
	Buf[2] := HC[WordRec(w).Lo Shr 4];
	Buf[3] := HC[WordRec(w).Lo And 15];
	WHex := Buf
End;

Function BHex(b: Byte): PChar;
Const Buf: Array[0..2]Of Char = '';
Begin
	Buf[0] := HC[b Shr 4];
	Buf[1] := HC[b And 15];
	BHex := Buf
End;

Procedure DASM(Var f: Text; s: PChar; Ret: Boolean);
Type
	Regs  = Array[0..7]Of PChar;
Const
	Reg16:  Regs = ('ax', 'cx', 'dx','bx', 'sp', 'bp', 'si', 'di');
	Reg08:  Regs = ('al', 'cl', 'dl','bl', 'ah', 'ch', 'dh', 'bh');
	RegSeg: Regs = ('es', 'cs', 'ss','ds', 'es', 'cs', 'ss', 'ds');
	Sarja2: Regs = ('add','or','adc','sbb','and','sub','xor','cmp');
	Sarja1: Regs = ('inc word ptr','dec word ptr','call','call far','jmp','jmp far','push word ptr','???');

	Jxxx:  Array[0..15]Of String[2] = ('o','no','b','nb','z','nz','be','a','s','ns','p','np','l','nl','le','g');
	ModCode:Array[0..7]Of String[5] = ('bx+si','bx+di','bp+si','bp+di','si','di','bp','bx');

Var
	Jump: PChar;
	Jumps: Array[0..15]Of PChar;
	Prefix: String[32];
	a, Indent: Byte;
	Addi: Integer;
	q: PChar;
	Ch: Char;

	Procedure DoModRM(s: PChar; b: Byte; Var R, R2: Regs);
	Var
		Parm1, Parm2: String[32];
		Buf: String[10];
		dd: Integer;
		l: LongInt;
	Begin
		If b < 2 Then Write(f, s, ' ');

		Parm1 := strpas(R[(Ord(q[0])Shr 3)And 7]);

		Case Ord(q[0])Shr 6 Of
			0:
			Begin
				If Ord(q[0])And 7 <> 6 Then
					Parm2 := Prefix+'[' + ModCode[Ord(q[0])And 7] + ']'
				Else
					{		 If PWord(q+1)^ = Ofs(PrefixSeg)Then Parm2 := 'PrefixSeg'
					Else}If PWord(q+1)^ = Ofs(BasePort) Then Parm2 := 'BasePort'
					Else Parm2 := Prefix+'[0' + strpas(WHex(PWord(q+1)^)) + 'h]'
			End;
			1:
			Begin
				l := ShortInt(q[1]);
				If(Ord(q[0])And 7 = 6)And(l > 0)Then dd := Addi Else dd := 0;
				Str(l + dd, Buf);

				If Buf[1] <> '-' Then Insert('+', Buf, 1);

				Parm2 := Prefix + '[' + ModCode[Ord(q[0])And 7] + Buf + ']'
			End;
			2:
			Begin
				l := PInteger(q+1)^;
				If(Ord(q[0])And 7 = 6)And(l > 0)Then dd := Addi Else dd := 0;
				Str(l + dd, Buf);

				If Buf[1] <> '-' Then Insert('+', Buf, 1);

				Parm2 := Prefix + '[' + ModCode[Ord(q[0])And 7] + Buf + ']'
			End;
			3:
				Parm2 := strpas(R2[Ord(q[0])And 7])
		End;

		Case b Of
			0: Write(f, Parm2,', ',Parm1);
			1: Write(f, Parm1,', ',Parm2);
			2: Write(f, Parm1,' ',Parm2);
		End;

		Inc(q, ModRM(q));

		Prefix := ''
	End;
Label P1, P2, P3;
Begin
	FillChar(Jumps, SizeOf(Jumps), 0);

	q := s;
	Addi := 0;
	Repeat
		Ch := q^;
		Inc(q);
		Case Ord(Ch) Of
			$40..$5F, $EC,$EE, $0E,$1E,$1F, $FC, $90..$99,
			$F2,$F3,$A6,$AE,
			$26,$2E,$36,$3E, $C9: ;

			$81: Inc(q, ModRM(q) + 2);
			$80, $82..$83: Inc(q, ModRM(q) + 1);

			$C8: Inc(q, 3);

			$00..$03, $08..$0B,
			$10..$13, $18..$1B,
			$20..$23, $28..$2B,
			$30..$33, $38..$3B,
			$88..$8C, $8E, $C4..$C5, $FF: Inc(q, ModRM(q));
			$04,$0C, $14,$1C, $24,$2C, $34,$3C, $B0: Inc(q);
			$70..$7F, $EB, $E2, $E3:
			Begin
				Jump := Ptr(Seg(q^), Ofs(q^)+1+ShortInt(q^));
				For a := 0 To High(Jumps)Do If Jump = Jumps[a]Then Goto P1;
				For a := 0 To High(Jumps) Do If Jumps[a] = Nil Then Break;
				Jumps[a] := Jump;
			P1:
				Inc(q);
			End;
			$C2,$C3: Break;
			$CA,$CB: Begin Dec(Addi, 2); Break End;
			$05,$0D, $15,$1D, $25,$2D, $35,$3D,
			$E8,$E9,$B8: Inc(q, 2);
			$9A: Inc(q, 4);
			Else
				Close(f);
				WriteLn('Unknown opcode: ',Ord(Ch),' (desim)!');
				Halt
		End
	Until False;

	Indent := 0;
	Prefix := '';
	q := s;
	Repeat
		For a := 0 To High(Jumps) Do
			If q = Jumps[a] Then
				Write(f, '@@',a+1,':');

		Ch := q^;
		Inc(q);

		If Ord(Ch)In[$58..$5F,$1F]Then Dec(Indent);

		If((Ch=#$C3)Or(Ch=#$CB))And Not Ret Then Exit;

		Write(f, #9, '':Indent);

P2:	Case Ord(Ch) Of
			$26: Begin Prefix := 'es:'; P3: Ch := q^; Inc(q); Goto P2 End;
			$2E: Begin Prefix := 'cs:'; Goto P3 End;
			$36: Begin Prefix := 'ss:'; Goto P3 End;
			$3E: Begin Prefix := 'ds:'; Goto P3 End;
			$40..$47: Write(f, 'inc ', Reg16[Ord(Ch)And 7]);
			$48..$4F: Write(f, 'dec ', Reg16[Ord(Ch)And 7]);
			$50..$57: Begin Write(f, 'push ',Reg16[Ord(Ch)And 7]); Inc(Indent)End;
			$1E:      Begin Write(f, 'push ds'); Inc(Indent)End;
			$58..$5F: Write(f, 'pop ', Reg16[Ord(Ch)And 7]);
			$1F:      Write(f, 'pop ds');
			$EC:      Write(f, 'in al, dx');
			$EE:      Write(f, 'out dx, al');
			$FC:      Write(f, 'cld');

			$B8:
			Begin
				Write(f, 'mov ax, 0',WHex(PWord(q)^),'h');
				Inc(q, 2)
			End;

			$05,$0D, $15,$1D, $25,$2D, $35,$3D:
			Begin
				Write(f, Sarja2[(Ord(Ch)Shr 3)And 7],' ax, ',PWord(q)^);
				Inc(q, 2)
			End;

			$C8:
			Begin
				WriteLn(f, 'push bp'#9'; enter ',PWord(q)^,',',Ord(q[2]));
				WriteLn(f, #9, '':Indent,'mov bp, sp');
				Case PWord(q)^ Of
					2: Write(f, #9, '':Indent,'push ax');
					Else Write(f, #9, '':Indent,'sub sp, ',PWord(q)^)
				End;
				Inc(q, 3)
			End;

			$C9:
			Begin
				WriteLn(f, 'mov sp, bp'#9'; leave');
				Dec(Indent);
				Write(f, #9, '':Indent,'pop bp')
			End;

			$B0: Begin Write(f, 'mov al, ',Ord(q^)); Inc(q)End;

			$04,$0C, $14,$1C, $24,$2C, $34,$3C:
			Begin
				Write(f, Sarja2[(Ord(Ch)Shr 3)And 7], ' al, ',Ord(q^));
				Inc(q)
			End;

			$90..$97: Write(f, 'xchg ',Reg16[Ord(Ch)And 7],', ax');
			$98: Write(f, 'cbw');
			$99: Write(f, 'cwd');
			{
			$F3:
			Begin
				Write(f, 'repe');
				If q[0] = #$A6 Then
				Begin
					Inc(q);
					Write(f, ' cmpsb')
				End
			End;

			$F2:
			Begin
				Write(f, 'repne');
				If q[0] = #$AE Then
				Begin
					Inc(q);
					Write(f, ' scasb')
				End
			End;
			}
			$00,$08, $10,$18, $20,$28, $30,$38:
				DoModRM(Sarja2[(Ord(Ch)Shr 3)And 7], 0, Reg08, Reg08);

			$01,$09, $11,$19, $21,$29, $31,$39:
				DoModRM(Sarja2[(Ord(Ch)Shr 3)And 7], 0, Reg16, Reg16);

			$02,$0A, $12,$1A, $22,$2A, $32,$3A:
				DoModRM(Sarja2[(Ord(Ch)Shr 3)And 7], 1, Reg08, Reg08);

			$03,$0B, $13,$1B, $23,$2B, $33,$3B:
				DoModRM(Sarja2[(Ord(Ch)Shr 3)And 7], 1, Reg16, Reg16);

			$88: DoModRM('mov', 0, Reg08, Reg16); $89: DoModRM('mov', 0, Reg16, Reg16);
			$8A: DoModRM('mov', 1, Reg08, Reg16); $8B: DoModRM('mov', 1, Reg16, Reg16);
			$C4: DoModRM('les', 1, Reg16, Reg16); $C5: DoModRM('lds', 1, Reg16, Reg16);
			$8C: DoModRM('mov', 0, RegSeg,Reg16); $8E: DoModRM('mov', 1, RegSeg,Reg16);

			$FF: DoModRM('', 2, Sarja1, Reg16);

			$80, $82:
			Begin
				Prefix := 'byte ptr '+Prefix;
				DoModRM('', 2, Sarja2, Reg08);
				Write(f, ', ', Ord(q[0]));
				Inc(q)
			End;

			$81:
			Begin
				Prefix := 'word ptr '+Prefix;
				DoModRM('', 2, Sarja2, Reg16);
				Write(f, ', ', PWord(q)^);
				Inc(q, 2)
			End;

			$83:
			Begin
				Prefix := 'word ptr '+Prefix;
				DoModRM('', 2, Sarja2, Reg16);
				Write(f, ', ', ShortInt(q[0]));
				Inc(q)
			End;

			$70..$7F, $EB,$E2,$E3:
			Begin
						 If Ch = #$E2 Then Write(f, 'loop')
				Else If Ch = #$E3 Then Write(f, 'jcxz')
				Else If Ch = #$EB Then Write(f, 'jmp')
				Else                   Write(f, 'j', Jxxx[Ord(Ch)And 15]);

				Write(f, ' @@');
				Jump := Ptr(Seg(q^), Ofs(q^)+1+ShortInt(q^));
				For a := 0 To High(Jumps)Do If Jump = Jumps[a]Then Write(f, a+1);
				Inc(q)
			End;
			$C3,$CB:
			Begin
				WriteLn(f, 'retn');
				Exit
			End;
			$C2,$CA:
			Begin
				WriteLn(f, 'retn ', PWord(q)^);
				Exit
			End;

			$0E:
			Begin
				If q[0] = #$E8 Then Goto P3;
				Write(f, 'push cs')
			End;
			$E8, $E9:
			Begin
				If Ch = #$E8
					Then Write(f, 'call ')
					Else Write(f, 'jmp ');

				Jump := Ptr(Seg(q^), Ofs(q^) + 2 + PInteger(q)^);

				For a := 0 To High(Jumps)Do If Jump = Jumps[a]Then Write(f, '@@',a+1);
				{If Jump = @StrNICmp Then Write(f, 'StrNICmp');}

				Inc(q, 2)
			End;
			$9A:
			Begin
				Write(f, 'call ');

				If Not Ret Then Write(f, '_');

						 If PLongInt(q)^ = LongInt(@_WriteDSP)Then Write(f, 'WriteDSP')
				Else If PLongInt(q)^ = LongInt(@_BitDelay)Then Write(f, 'BitDelay'){
				Else If PLongInt(q)^ = LongInt(@StrNICmp)Then  Write(f, 'StrNICmp')
				Else                                           Write(f, '911')};
				Inc(q, 4)
			End;
			Else
				Close(f);
				WriteLn('???');
				Halt
		End;

		WriteLn(f)
	Until False
End;

Procedure Show13;
Var
	y, mo,d,wd: Word;
	h,mi,sec,s100: Word;
	p, q: PChar;
	b: Byte;
	f: Text;
	f2: File;
Begin
	Kompress(Not Optimizing);

	p := strrscan(Name, '\');
	If p = Nil
		Then p := Name
		Else Inc(p);

	q := strrscan(Name, '.');
	If q = Nil Then
		s := strpas(strupper(p))
	Else
	Begin
		s[0] := Chr(q-p);
		For b := 1 To Ord(s[0])Do s[b] := UpCase(p[b-1])
	End;

	For b := 1 To Length(s)Do If s[b]='_' Then Delete(s,b,1);

	If FileLoadDebug Then Debug('Opening output file TMPTMP.BAS');
	Assign(f, 'TMPTMP.BAS');
	ReWrite(f);

	GetDate(y,mo,d,wd);
	GetTime(h,mi,sec,s100);

	Assign(f2, CompressorTemp);
	Reset(f2, 1);

	Write(f,
		'DEFINT A-Z ''$DYNAMIC'^J+

		'DECLARE FUNCTION InitSound%()'^J+
		'DECLARE SUB DoneSound()'^J+
		'DECLARE SUB SetBasePort(BYVAL a%)'^J,
		'DECLARE SUB InitSample(BYVAL SmpNum%,BYVAL Index%,BYVAL Value%)'^J+
		'DECLARE SUB SetSound(BYVAL Chan%,BYVAL Herz%,BYVAL Volume%)'^J+
		'declare function GetRate%()'^J^J+

		'DIM Laulu(-1TO ',Riveja-1,',0TO ',LastChan,
		'),Period(11),Vol(3),Herz(3)');

	If Not Optimizing Then Write(f, ',Dot(3),N(3)');

	WriteLn(f, #10'?"Generated by ',Title,
		'"'^J'?"Generation time: ',
			d, '.', mo, '.', y, ' ',
			Chr(h Div 10+48), Chr(h Mod 10+48), ':',
			Chr(mi Div 10+48), Chr(mi Mod 10+48), ':',
			Chr(sec Div 10+48), Chr(sec Mod 10+48),
			', file: ', Name, '"'^J+
		'a#=560:FOR y=0TO 11:Period(y)=a#:a#=a#*2^(1/12):NEXT');

	Show11WriteLukija(f);

	WriteLn(f,
		'P=',TicPeriod*5 Div 4,':',
		'?"done - calibrating delay loop";'^J+
		'Ti#=TIMER:?space$(30);:locate csrlin,pos(0)-30'^J+
		'FOR a#=0TO 999999:IF TIMER-Ti#>2 THEN EXIT FOR'^J+
		'?"";:NEXT:b#=a#\(P*(TIMER-Ti#)):?" -";b#;"loops"'^J);

	WriteLn(f,
		'BasePort=&H220'^J+
		'DO:SetBasePort BasePort'^J+
		#9'IF InitSound%=0THEN EXIT DO'^J+
		#9'IF BasePot>&H270THEN ?"Soundcard not found!":END'^J+
		#9'BasePort=BasePort+16'^J+
		'LOOP:?"SB found at ";HEX$(BasePort);"h"'^J,
		'FOR x=0TO 2047'^J+
		#9'IF x<512THEN y=0ELSE y=4000'^J+
		#9'InitSample 0,x,y'^J,
		#9'IF x<1024THEN y=x ELSE y=2048-x'^J+
		#9'InitSample 1,x,y*2'^J+
		#9'InitSample 2,x,RND*4000'^J+
		'NEXT');

	If Not Optimizing Then
	Begin
		WriteLn(f,
			'COLOR 8:?SPACE$(400);:DEF SEG=&HB800'^J+
			'COLOR 7',':?"(Q)uit"',';'^J'y=CSRLIN-4:LOCATE y-1,1:')
	End;

	Write(f,
		#10'?"Rows/Sec:";STR$(P);", sampling rate";GetRate;"Hz"');

	If Optimizing Then Write(f, ':?"(Q)uit"');

	Write(f,
		#10'DO'^J#9'FOR j=0TO ');

	If Optimizing Then Write(f, LastChan)ELse Write(f, '3');

	WriteLn(f,
		#10#9#9'N(j)=Laulu(R,j)AND 15'^J+
		#9#9'IF D(j)THEN Vol(j)=0ELSE Vol(j)=Laulu(R,j)\256');

	If Not Optimizing Then
		WriteLn(f,
			#9#9'COLOR 6+D(j)*2:FOR ny=0TO 3:LOCATE y+ny,1+j*10,0:c$=" ":IF Dot(j)\2>3-',
					'ny THEN c$=""ELSE IF(Dot(j)\2=3-ny)AND(Dot(j)AND 1)THEN c$=""'^J+
			#9#9'?STRING$(6,c$);:NEXT'^J,
			#9#9'IF j<2THEN Dot(j)=Laulu(R,j)\512ELSE IF Laulu(R,j)\256>Laulu(R-1,j)\256',
					'THEN Dot(j)=8ELSE IF Dot(j)>0THEN Dot(j)=Dot(j)-1');

	WriteLn(f,
		#9#9'IF(Laulu(R,j)AND 255)<254THEN Herz(j)=Period(N(j))*(2^((Laulu(R,j)\16)and 15))'^J+
		#9#9'V=Vol(j)*4:SetSound j,Herz(j)\30,V');

	If Not Optimizing Then
		WriteLn(f,
			#9#9's$="      ":IF Laulu(R,j)\256THEN s$=MID$("A-A#B-C-C#D-D#E-F-F#G-G#",('+
					'N(j))*2+1,2)+LTRIM$(STR$((Laulu(R,j)AND 255)\16))+" "+CHR$((('+
					'Laulu(R,j)\256)*4)\10+48)+CHR$(((Laulu(R,j)\256)*4)MOD 10+48)'^J,
			#9#9'COLOR 7+D(j):LOCATE y+4,41+j*10:?s$;');

	WriteLn(f, #9'NEXT');

	BlankChar := #9;
	If Not Optimizing Then
		WriteLn(f,
			#9'LOCATE y+4,38,1,13,14'^J+
			#9'FOR ny=1TO 5:FOR j=0TO 79STEP 2'^J+
			#9#9'a=PEEK((ny+y-2)*160+j+40*2):POKE(ny+y-3)*160+j+40*2,a'^J+
			#9'NEXT j,ny');

	BlankChar := ' ';

	Write(f,
		#9'FOR a#=0TO b#:IF TIMER=a#THEN a#=a#'^J#9'NEXT'^J+
		#9'R=R+1:IF R>=');

	Show11WriteRiveja(f);

	Write(f,' THEN R=');

	If Optimizing Then Write(f, Looppaa)Else Write(f, 'Looppaa');

	WriteLn(f,
		#10#9'SELECT CASE INKEY$'^J+
		#9#9'CASE"1":D(0)=1-D(0)'^J+
		#9#9'CASE"2":D(1)=1-D(1)'^J+
		#9#9'CASE"3":D(2)=1-D(2)'^J+
		#9#9'CASE"4":D(3)=1-D(3)'^J+
		#9#9'CASE"":'^J,
		#9#9'CASE"Q","q":EXIT DO'^J+
		#9'END SELECT'^J+
		'LOOP'^J,
		'DoneSound',
		#10'?:SYSTEM');

	Write(f, BasicBlock7Txt, BasicBlock6Txt);

	If Optimizing Then Seek(f2, 4);

	y := 0;
	d := 1;
	While Not Eof(f2)Do
	Begin
		BlockRead(f2, b, 1, h);
		If h=0 Then Break;
		If y>29 Then Begin WriteLn(f, ',',d:3,',',mo); Inc(d); y := 0 End;
		If y=0 Then Begin mo := 0; Write(f, 'DATA ')End;
		Inc(mo, b);
		Write(f, BHex(b));
		Inc(y)
	End;

	Close(f);
	Close(f2);
	Erase(f2);
	TabFix(f, f2, 'TMPTMP.BAS', 2);

	WriteLn('Written TMPTMP.BAS')
End;

Var
	ResItemCount: Word;

Procedure Show14;
Var
	s2: String[16];
	y, mo,d,wd: Word;
	j,h,mi,sec,s100: Word;
	p, q: PChar;
	a, l, l2: LongInt;
	b: Byte;
	f: File;
	t: Text;
	Opt: Boolean;
Begin
	If Name[0] = #1 Then
	Begin
		Debug('Initializing temporary file...');
		ResItemCount := 0;
		Assign(f, CompressorTemp);
		ReWrite(f, 1);
		Close(f);
		Exit
	End;

	If Name[0] <> #0 Then
	Begin
		p := strrscan(Name, '\');
		If p = Nil
			Then p := Name
			Else Inc(p);

		q := strrscan(Name, '.');
		If q = Nil Then
			s := strpas(strupper(p))
		Else
		Begin
			s[0] := Chr(q-p);
			For b := 1 To Ord(s[0])Do s[b] := UpCase(p[b-1])
		End;

		s2 := s;
		For b := 1 To Length(s)Do If s[b]='_' Then Delete(s,b,1);

		If Debugging Then WriteLn('Adding ',s2,' to temporary file...');

		Assign(f, CompressorTemp);
		FileMode := 1;
		Reset(f, 1);
		fseek(f, 0, SEEK_END);
		BlockWrite(f, s2, Length(s2)+1);
		BlockWrite(f, s, Length(s)+1);
		s := strpas(PChar(@Hdr));
		BlockWrite(f, s, Length(s)+1);
		l := FilePos(f);
		BlockWrite(f, a, 4);
		Close(f);
		FileMode := 0;

		Inc(ResItemCount);

		DAPLBits := 10;
		DaplKompress(False);

		FileMode := 2;
		Reset(f, 1);
		Seek(f, l);
		a := FileSize(f) - (l+4);
		BlockWrite(f, a, 4);
		Close(f);

		FileMode := 0;

		Exit
	End;

	If FileLoadDebug Then Debug('Opening output file TMPTMP.BAS');
	Assign(t, 'tmptmp.bas');
	ReWrite(t);

	GetDate(y,mo,d,wd);
	GetTime(h,mi,sec,s100);

	If Debugging
		Then WriteLn('Writing most of the code.')
		Else WriteLn('Writing...');

	WriteLn(t,
		'DEFINT A-Z ''$DYNAMIC'^J+
		'DECLARE SUB WriteR(I,D)'^J+
		'DIM Laulu(-1TO 1,0TO 3),Period(11),D(4),Vol(3),Herz(3),Dot(3),N(3)'^J,
		'WriteR 4,96:WriteR 4,128:a=INP(&H388)'^J+
		'WriteR 2,255:WriteR 4,33:t#=TIMER:t#=TIMER:b=INP(&H388)'^J+
		'WriteR 4,96:WriteR 4,128'^J+
		'IF((a AND&HE0))OR((b AND&HE0)<>&HC0)THEN ?"FM sound not available."'^J^J,
		'a#=504 ''Base value for period table'^J+
		'FOR y=0TO 11:Period(y)=a#:a#=a#*2^(1/12):NEXT'^J+
		'COLOR 7,0:CLS:LOCATE 15:COLOR 11,1');

	WriteLn(t, #10,'?USING"\"+SPACE$(78)+"\";"Generat','ed by ',Title,
				 '";'#10,'?USING"\"+SPACE$(78)+"\";"Generat','ion time: ',
				 d, '.', mo, '.', y, ' ',
				 Chr(h Div 10+48), Chr(h Mod 10+48), ':',
				 Chr(mi Div 10+48), Chr(mi Mod 10+48), ':',
				 Chr(sec Div 10+48), Chr(sec Mod 10+48));

	WriteLn(t,
		'LOCATE 1:COLOR 14,4:?USING "\"+SPACE$(78)+"\";"Select song"'^J^J+
		's=0:DO:y$=INKEY$:GOSUB Selection:LOOP'^J+
		'ReadIt:GOSUB Vai:a=s:GOSUB Sel:LOCATE 1,1:COLOR 14,4:GOSUB Lue'^J);

	If Not AutoTicker Then Write(t, 'P=',TicPeriod,':');

	WriteLn(t,
		'?"done - calibrating delay loop";'^J+
		'Ti#=TIMER:?space$(30);:locate csrlin,pos(0)-30'^J+
		'FOR a#=0TO 999999:IF TIMER-Ti#>2 THEN EXIT FOR'^J+
		'?"";:NEXT:b#=a#\(P*(TIMER-Ti#)):?" -";b#;"loops"'^J);

	WriteLn(t,
		'y=19:LOCATE y-1,1:COLOR 8,0:?SPACE$(400);:DEF SEG=&HB800'^J+
		'COLOR 7:?"(Q)uit":LOCATE y-1,1',
		#10'?"Using FM synthesis, sampling rate";STR$(P);"Hz"');

	WriteLn(t,
		'DO'^J+
		#9'FOR j=0TO 3'^J+
		#9#9'N(j)=Laulu(R,j)AND 15'^J+
		#9#9'IF D(j+1)THEN Vol(j)=0ELSE Vol(j)=Laulu(R,j)\256'^J,
		#9#9'COLOR 6+D(j+1)*2:FOR ny=0TO 3:LOCATE y+ny,1+j*10,0:c$=" ":IF Dot(j)\2>3-',
				 'ny THEN c$="" ELSE IF(Dot(j)\2=3-ny)AND(Dot(j)AND 1)THEN c$=""'^J+
		#9#9'?STRING$(6,c$);:NEXT'^J,
		#9#9'IF j<2THEN Dot(j)=Laulu(R,j)\512ELSE IF Laulu(R,j)\256>Laulu(R-1,j)\256'+
				 'THEN Dot(j)=8ELSE IF Dot(j)>0 THEN Dot(j)=Dot(j)-1'^J+
		#9#9'IF(Laulu(R,j)AND 255)<254THEN Herz(j)=Period(N(j))'^J,
		BasicBlock8Txt,

		#9#9'D1=-3*(j=3):D2=-10*(j<2):O=j-5*(j=3)'^J+
		#9#9'D3=D2:D4=242+2*(j<3):D0='+{'D2\1'+}'0:D10=0'^J+
		#9#9'IF j>1THEN D10=12*j-21:IF j=3THEN D3=10+30*(j-2):D0=3'^J,

		#9#9'WriteR 64+O,(D2 AND 192)OR(63-((63-(D2 AND 63))*V/64))'^J+
		#9#9'WriteR 67+O,(D3 AND 192)OR(63-((63-(D3 AND 63))*V/64))'^J+
		#9#9'IF Vol(j)=0THEN'^J+
		#9#9#9'WriteR &HB0+j,0'^J+
		#9#9'ELSE'^J,
		#9#9#9'WriteR 32+O,D0:WriteR 35+O,D1:WriteR 96+O,D4:WriteR 99+O,D4'^J+
		#9#9#9'WriteR &HE0+O,D8:WriteR &HC0+j,D10:WriteR &HA0+j,Herz(j)AND 255'^J+
		#9#9#9'WriteR &HB0+j,32OR((Herz(j)\256)AND 3)OR(1+(Laulu(R,j)AND 255)\16)*4'^J,
		#9#9'ENDIF'^J,

		#9#9's$="      ":IF Laulu(R,j)\256THEN s$=MID$("A-A#B-C-C#D-D#E-F-F#G-G#",('+
				'N(j))*2+1,2)+LTRIM$(STR$((Laulu(R,j)AND 255)\16))+" "+CHR$(('+
				'Laulu(R,j)\256)\10+48)+CHR$((Laulu(R,j)\256)MOD 10+48)'^J,
		#9#9'COLOR 7+D(j+1):LOCATE y+4,41+j*10:?s$;',
		#10#9'NEXT'^J,

		#9'LOCATE y+4,38,1,13,14'^J+
		#9'FOR ny=1TO 5:FOR j=0TO 79STEP 2'^J+
		#9#9'a=PEEK((ny+y-2)*160+j+40*2):POKE(ny+y-3)*160+j+40*2,a'^J+
		#9'NEXT j,ny'^J,

		#9'FOR a#=0TO b#:IF TIMER=a#THEN a#=a#'^J#9'NEXT'^J+
		#9'R=R+1:IF R>=Riveja THEN R=Looppaa'^J+
		#9'y$=INKEY$'^J+
		#9'IF y$<>""THEN'^J,
		#9#9'IF UCASE$(y$)="Q"OR ASC(y$)=27THEN EXIT DO'^J+
		#9#9'IF VAL(y$)<5THEN D(VAL(y$))=1-D(VAL(y$))'^J+
		#9#9'GOSUB Selection'^J+
		#9'END IF'^J+
		'LOOP');

	Write(t,
		'GOSUB Vai'^J+
		'Moi:?:SYSTEM'^J+
		'Vai:FOR j=0TO 244:WriteR j,0:NEXT', BasicBlock6Txt,

		'Selection:'^J+
		#9'COLOR 7,0'^J+
		#9'IF UCASE$(y$)="Q"OR y$=CHR$(27)THEN LOCATE 17,1,1:GOTO Moi'^J+
		#9'IF y$=CHR$(13)OR y$=" "THEN RETURN ReadIt'^J,
		#9'IF y$=CHR$(0)+"H"THEN s=(s+m-1)MOD m'^J+
		#9'IF y$=CHR$(0)+"P"THEN s=(s+1)MOD m'^J+
		#9'FOR a=0TO 25'^J+
		#9#9'GOSUB Sel:IF a>=m THEN EXIT FOR'^J+
		#9#9'LOCATE 2+a MOD 13,1+(a\13)*40,0'^J+
		#9#9'COLOR 7,0:IF a=s THEN COLOR 0,7'^J,
		#9#9'?USING"\      \\"+SPACE$(29)+"\";c$;": "+s$;'^J+
		#9'NEXT:COLOR 7,0', BasicBlock6Txt,

		'Red:'^J+
		#9'IF Red$=""THEN RPos=0:READ Red$'^J+
		#9'u$=left$(red$,1):s$=mid$(Red$,2,255)'^J+
		#9'IF u$>"F"THEN b=asc(u$)-71:Red$=s$ ELSE ',
			'IF u$="="THEN b=56:Red$=s$ ELSE ',
			'IF u$<"0"THEN b=208+asc(u$):Red$=s$ ELSE ',
			'b=VAL("&H"+left$(Red$,2)):Red$=mid$(Red$,3,255)'^J+
		#9'RPos=RPos+1'{:b=(b+255)AND 255'}, BasicBlock6Txt);

	WriteLn(t, 'Lue:Red$="":R=0:Rivi=0',
			#10'GOSUB Red:a=b:','GOSUB Red:','Riveja','=a+b*256',
			#10'GOSUB Red:a=b:','GOSUB Red:','Looppaa','=a+b*256');

	If AutoTicker Then WriteLn(t, 'GOSUB Red:P=b');

	WriteLn(t,
			'Rivi=0'^J+
			'REDIM Laulu(-1TO Riveja-1,0TO 3)'^J,

			'?"Loading";SPACE$(50);:LOCATE ,9'^J'ON ERROR GOTO Vi'^J+
			'FOR y=0TO 3:w=0'^J+
			#9'DO:?STR$((y*Riveja+w)*25!\Riveja);"%";:LOCATE,9,1'^J+
			#9#9'GOSUB Red'^J+
			#9#9'j=b:GOSUB Red'^J,
			#9#9'IF j=255THEN'^J+
			#9#9#9'j=b:','GOSUB Red:','b=b+(j\64)*256:j=j AND 63'^J,
			#9#9#9'WHILE j>0:Laulu(w,y)=Laulu(w-b,y):j=j-1:w=w+1:WEND'^J+
			#9#9'ELSE'^J+
			#9#9#9'Laulu(w,y)=b*256+j:w=w+1'^J+
			#9#9'END IF'^J+
			#9'LOOP UNTIL w>=Riveja',
			#10'NEXT', BasicBlock6Txt,
			'Vi:?"Failed - ERROR!":LOCATE 17,1:COLOR 7,0:BEEP:SYSTEM'^J);

	Write(t, 'Sel:m=',ResItemCount,':ON a+1GOSUB ');

	Debug('Reading the temporary file.');

	FileMode := 0;
	Assign(f, CompressorTemp);
	Reset(f, 1);

	If Debugging Then Write(' Scanning... ');

	For j := 1 To ResItemCount Do
	Begin
		BlockRead(f, s[0], 1);
		BlockRead(f, s[1], Length(s));

		If Debugging Then Write(s);

		BlockRead(f, s[0], 1);
		BlockRead(f, s[1], Length(s));

		Write(t, s);
		If j<ResItemCount Then
		Begin
			Write(t, ',');
			If Debugging Then Write(', ')
		End;

		BlockRead(f, s[0], 1);
		BlockRead(f, s[1], Length(s));
		BlockRead(f, a, 4);
		fseek(f, a, SEEK_CUR)
	End;
	Write(t, #10'READ c$,s$', BasicBlock6Txt);

	If NoBrains Then WriteLn('Now writing the data. As there are no brains, this may take a long time.');

	If Debugging Then Write(#13^J' Reading...');
	Seek(f, 0);
	l2 := 0;
	For j := 1 To ResItemCount Do
	Begin
		BlockRead(f, s2[0], 1);
		BlockRead(f, s2[1], Length(s2));

		BlockRead(f, s[0], 1);
		BlockRead(f, s[1], Length(s));
		Write(t, s,':RESTORE ',s,':RETURN'^J'DATA ',s2,',');
		Inc(l2, Length(s2));

		If Debugging Then Write(s);

		BlockRead(f, s[0], 1);
		BlockRead(f, s[1], Length(s));
		Inc(l2, Length(s)+4);
		WriteLn(t, s);

		BlockRead(f, a, 4);

		If Debugging And DosMemDebug Then Write('(',a,' bytes)');

		y := 0;
		While a > 0 Do
		Begin
			BlockRead(f, b, 1, h); Dec(a);
			If h=0 Then Break;
			If y>246 Then Begin WriteLn(t); Inc(l2,5); y := 0 End;
			If y=0 Then Write(t, 'DATA ');

			{
				Map:
							 0..55:  'G'..'~' (71..126)
									56:  '='
							57..184: ''..'' (128..255)
									241: '!'      (33)
						 243..246: '#'..'&' (35..38)
						 248..251: '('..'+' (40..43)
						 253..255: '-'..'/' (45..47)
						185..240,
					242,247,252: [0-9A-F]*2 (hex)
			}

			{Inc(b);}

			If b=56 Then Write(t, '=')
			Else If(b < 185)Then Write(t, Chr(b+71))
			Else If(b > 240)And(b<>242)
					 And(b<>247)And(b<>252)Then Write(t, Chr(b-208))
			Else Begin Inc(y);Inc(l2);Write(t, BHex(b))End;
			Inc(l2);
			Inc(y)
		End;

		If Debugging And (j<ResItemCount)Then Write(', ');
		WriteLn(t, #10)
	End;

	WriteLn(t, #10^J+
		'SUB WriteR(I%,D%)'^J+
		#9'OUT&H388,I%:a%=INP(&H388):OUT&H389,D%:a%=INP(&H388)'^J+
		'END SUB'^J);

	Debug(#13^J'Closing files, erasing temporary file.');
	Close(t); Close(f); Erase(f);

	WriteLn('Written TMPTMP.BAS - DATA size about ',l2,' bytes.');
	If l2 > 57700 Then
	Begin
		WriteLn('':21,'(Which may be too much, note!)');

		If NoBrains Then
			WriteLn('':21,'(That was expectable when not having brains.)')
		Else
			If Not MustTryMore Then
				WriteLn('':21,'(Gain less size by using -O option.)')
	End;

	TabFix(t, f, 'TMPTMP.BAS', 2)
End;

Procedure OBJSave(Pakkaaja: Kompressor);
Const
	s1: Array[0..11]Of Char = ''#4#0#2'::'#8#0#0#1;
	s2: Array[0..12]Of Char = #0'C'#7#0'(??'#2#1#1'?';
	s3: Array[0..3] Of Char = #0#0#0'?';
	s4: Array[0..5] Of Char = #$A0'??'#1#0#0;
	s5: Array[0..4] Of Char = ''#2#0#0't';
	CSeg: String[4] = 'CODE';
Var
	Buf: Array[0..255]Of Char;
	fn: String;
	a, c, w, w2: Word;
	b, j: Byte;
	l: LongInt;
	f, f2: File;
	p, q: PChar;
Begin
	p := strrscan(Name, '\');
	If p = Nil
		Then p := Name
		Else Inc(p);

	q := strrscan(Name, '.');
	If q = Nil Then
		s := strpas(strupper(p))
	Else
	Begin
		s[0] := Chr(q-p);
		For a := 1 To Ord(s[0])Do s[a] := UpCase(p[a-1])
	End;

	fn := s + '.OBJ';

	Pakkaaja(False);

	Assign(f2, CompressorTemp);
	Reset(f2, 1);

	If Debugging Then WriteLn('Opening ',fn);
	Assign(f, fn);
	ReWrite(f, 1);

	b := 0;

	Debug('Writing headers');
	BlockWrite(f, s1, 11);
	BlockWrite(f, CSeg, Length(CSeg)+1);
	BlockWrite(f, s2, 13);

	j := Length(s)+7;
	BlockWrite(f, j, 1);
	BlockWrite(f, s1[9], 3);
	BlockWrite(f, s, Length(s)+1);
	BlockWrite(f, s3, 4);

	Debug('Writing compressed image');
	l := FileSize(f2);
	c := 0;

	While l > 0 Do
	Begin
		If l > 1024
			Then w := 1024
			Else w := l;
		Inc(w, 4);
		s4[1] := Chr(Lo(w));
		s4[2] := Chr(Hi(w));
		s4[4] := #0;
		s4[5] := Chr(c);
		Dec(w, 4);
		BlockWrite(f, s4, 6);

		Inc(c, 4);

		w2 := w;
		Repeat
			a := w2;
			If a > SizeOf(Buf)Then a := SizeOf(Buf);
			BlockRead(f2, Buf, a);
			BlockWrite(f, Buf, a);
			Dec(w2, a)
		Until w2 = 0;
		Dec(l, w);

		BlockWrite(f, b, 1) {Checksum}
	End;

	l := FileSize(f2);

	Debug('Erasing temporary file');
	Close(f2);
	Erase(f2);

	Debug('Writing footers');
	BlockWrite(f, s5, 5);

	Seek(f, 22);
	BlockWrite(f, l, 2); {tiedoston koko}

	Seek(f, 27);
	BlockWrite(f, b, 1); {checksum}

	Seek(f, 45-8+Length(s));
	BlockWrite(f, b, 1); {checksum}

	Debug('Finished, closing.');
	Close(f);

	WriteLn('Written ',fn)
End;

Procedure Show7;
Begin
	OBJSave(Kompress)
End;

Procedure Show9;
Begin
	OBJSave(DaplKompress)
End;

Procedure Show10;
Const
	THEADR1: Array[0..16]Of Char = #$80'???Generated by ';
	LNAMES: Array[0..8]Of Char = #$96#$06#$00#$04'CODE'#0;
	SEGDEF: Array[0..9]Of Char = #$98#$07#$00#$28'??'#$01#$01#$01#0;
	PUBDEF1:Array[0..4]Of Char = #$90'??'#$00#$01;
	PUBDEF2:Char               = #0;
	LEDATA1:Array[0..5]Of Char = #$A0'??'#$01'??';
	MODEND: Array[0..3]Of Char = #$8A#$01#$00#0;
Var
	LEDATA2:Char Absolute PUBDEF2;
	THEADR2:Char Absolute PUBDEF2;

Var
	Buf: Array[0..1023]Of Char;
	f, t: File;
	a, l: LongInt;
	q, p: PChar;
	w, i: Word;
	b: Byte;
Begin
	If Name[0] = #1 Then
	Begin
		Debug('Initializing temporary file...');
		Assign(f, CompressorTemp);
		ResItemCount := 0;
		ReWrite(f, 1);
		Close(f);
		Exit
	End;

	If Name[0] <> #0 Then
	Begin
		p := strrscan(Name, '\');
		If p = Nil
			Then p := Name
			Else Inc(p);

		q := strrscan(Name, '.');
		If q = Nil Then
			s := strpas(strupper(p))
		Else
		Begin
			s[0] := Chr(q-p);
			For a := 1 To Ord(s[0])Do s[a] := UpCase(p[a-1])
		End;

		If Debugging Then WriteLn('Adding ',s,' to temporary file...');

		Assign(f, CompressorTemp);
		FileMode := 1;
		Reset(f, 1);
		fseek(f, 0, SEEK_END);
		BlockWrite(f, s, Length(s)+1);
		l := FilePos(f);
		BlockWrite(f, a, 4);
		Close(f);
		FileMode := 0;

		Inc(ResItemCount);

		DaplKompress(False);

		FileMode := 2;
		Reset(f, 1);
		Seek(f, l);
		a := FileSize(f) - (l+4);
		BlockWrite(f, a, 4);
		Close(f);

		FileMode := 0;

		Exit
	End;

	If FileLoadDebug Then Debug('Opening output file TMPTMP.OBJ');
	Assign(f, 'tmptmp.obj');
	ReWrite(f, 1);

	THEADR1[3] := #26;
	PWord(@THEADR1[1])^ := Ord(THEADR1[3])+2;
	BlockWrite(f, THEADR1, SizeOf(THEADR1));
	BlockWrite(f, Title, Ord(THEADR1[3])-13);
	BlockWrite(f, THEADR2, SizeOf(THEADR2));
	BlockWrite(f, LNAMES, SizeOf(LNAMES));

	Debug('Scanning segment length');

	Assign(t, CompressorTemp);
	Reset(t, 1);

	l := 0;
	i := 0;

	PWord(@PUBDEF1[1])^ := 3;

	For w := 1 To ResItemCount Do
	Begin
		BlockRead(t, b, 1); fseek(t, b, SEEK_CUR);

		Inc(PWord(@PUBDEF1[1])^, 4 + b);

		BlockRead(t, a, 4); Inc(l, a);
		fseek(t, a, SEEK_CUR);
		Inc(i)
	End;

	If l > 65520 Then
	Begin
		Close(f);
		Write('*** Data size is ', l);
		Error(' bytes --- TOO BIG!')
	End;

	If Debugging And DosMemDebug Then
		WriteLn(' Segment size is ', l,' bytes');

	PWord(@SEGDEF[4])^ := l;

	BlockWrite(f, SEGDEF, SizeOf(SEGDEF));

	Debug('Writing PUBDEFs, scanning temporary file...');

	BlockWrite(f, PUBDEF1, SizeOf(PUBDEF1));

	i := 0;
	Seek(t, 0);
	For w := 1 To ResItemCount Do
	Begin
		BlockRead(t, s, 1);
		BlockRead(t, s[1], Length(s));

		BlockWrite(f, s, Length(s)+1);
		BlockWrite(f, i, 2);
		BlockWrite(f, PUBDEF2, 1);

		BlockRead(t, a, 4); Inc(i, a);
		fseek(t, a, SEEK_CUR)
	End;

	BlockWrite(f, PUBDEF2, 1);

	Debug('Writing data');
	i := 0;
	Seek(t, 0);
	For w := 1 To ResItemCount Do
	Begin
		BlockRead(t, b, 1); fseek(t, b, SEEK_CUR);
		BlockRead(t, a, 4);
		While a > 0 Do
		Begin
			l := SizeOf(Buf);
			If l > a Then l := a;
			PWord(@LEDATA1[1])^ := l+4; {koko = indexbyte + offsetword + data + ck}
			PWord(@LEDATA1[4])^ := i;   {offsetti}
			BlockWrite(f, LEDATA1, SizeOf(LEDATA1));
			BlockRead (t, Buf, l);
			BlockWrite(f, Buf, l);
			BlockWrite(f, LEDATA2, 1);  {ck}
			Inc(i, l);
			Dec(a, l)
		End
	End;

	Debug('Finishing');

	BlockWrite(f, MODEND, SizeOf(MODEND));

	WriteLn('Written TMPTMP.OBJ');

	Debug('Closing files');

	Close(f);
	Close(t)
End;

End.
